%% Parameters 
% dem file name 
%filename_dem = 'S:\Mohrigs Share\Lidar_Trinity\Trinity_2011_2017_combine\2011_2017_combine\c2019_10_22_2011fill100_2017fill100_bathy10m_topo2raster_oxbow_NCEIesturary_floodplainmin5_fillallelevationgreaterthan100000m2_valleysmoth.tif';
% detrended dem file name 1m trend from 10m bilinear subsampled data
filename_dem = 'S:\Mohrigs Share\Lidar_Trinity\Trinity_2011_2017_combine\2019_10_31_final_product\bathylidar\c2019_10_22_2011fill100_2017fill100_bathy10m_topo2raster_oxbow_NCEIesturary_floodplainmin5_fillallelevationgreaterthan100000m2.tif';
%dem file name no interpolated bathymetry or floodplian
filename_dem_floodplain = 'C:\Users\hjh739\Lidar_Trinity\Trinity_2011_2017_combine\c2011fill100_2017fill100_valleysmooth.tif';
% centerline file name 
filename_center = "S:\Mohrigs Share\Hima_Trinity\LeveeCode\transect_extract\centerline_50m_pts.shp";
% demNaN 
demError = 3.402823466385289e+38;%3.402823060737097e+38;
% cross section length (should be larger than widest levee
cross_len = 2000; %m on either side of centerline
midpt = cross_len;
% cross section spacing 
cross_space = 1; %m 
% swath width 
swath_width = 25; %m actually twice since  used on both sides 
% remove extra transect values around centerlines 
centerline_buffer = 50;
% quantile between 0 and 1 below which levee crest unlikely real
elev_quantile_lower = 0.2;
% bathymetry characteristics 
bathy_dem = 1; % if ==1 then bathymetry included in dem 
% variable to determine plotting 
plotting_transect = 0; % if ==1 then plot data
% weight of elevation vs distance when sorting both for thalweg and crest
% picking (0,1) zero no elevation contribution 1 only elevation
% contribution
weight_thal = 0.7;
weight_elev = 0.4;
weight_diff = 0.3;
weight_loc = 0.3;

%detrended elevation distance to average over
detrended_length = 300;
%% Load DEM data
% import DEM % use readgeoraster if version greater than 2020a
[dem_Array, dem_SpatialReference] = geotiffread(filename_dem);
% define bounding box
info = geotiffinfo(filename_dem);  % if greater than 2020a georasterinfo
info.xLowerLeftCoord = info.BoundingBox(1,1);
info.yLowerLeftCoord = info.BoundingBox(1,2);
info.yUpperRightCoord = info.BoundingBox(2,2);

demError = max(max(dem_Array));
ismember(demError,dem_Array)
dem_Array = standardizeMissing(dem_Array,demError); 
[x_dem,y_dem] = pixcenters(dem_SpatialReference,size(dem_Array));
R = makerefmat(x_dem(1),y_dem(1),1,-1);

%% Load DEM data for floodplain extraction 
% % import DEM % use readgeoraster if version greater than 2020a
% [floodplain_dem_Array, floodplain_dem_SpatialReference] = geotiffread(filename_dem_floodplain);
% 
% demError = max(max(floodplain_dem_Array));
% ismember(demError,floodplain_dem_Array)
% floodplain_dem_Array = standardizeMissing(floodplain_dem_Array,demError); 


 %% Load detrended DEM data
% % import DEM % use readgeoraster if version greater than 2020a
% [detrended_dem_Array, detrended_dem_SpatialReference] = geotiffread(filename_detrend_dem);
% 
% demError = min(min(detrended_dem_Array));
% ismember(demError,detrended_dem_Array)
% detrended_dem_Array = standardizeMissing(detrended_dem_Array,demError); 

%% Load Centerline data 
c = shaperead(filename_center);
% from imported centerline
centerline = [[c.X].',[c.Y].'];
[~,i_sort] =sort([c.m]);
centerline = centerline(i_sort,:);
len_center = length(centerline);
distance_downstream_automated= [c([1:len_center]).m];
%% load levee extent dataset traced from dem
fid = fopen(fullfile('S:\Mohrigs Share\Hima_Trinity\10_13_2020_levee_extent_tracing','2020_10_13_levee_extent_pts.txt'));
%FID	Id	ORIG_FID	Id_1	POINT_X	POINT_Y
levee_extent = textscan(fid,'%f %f %f %f %f %f','HeaderLines',1,'Delimiter',',');
fclose(fid);

% load data from intersects between levees and polygon
fid = fopen(fullfile('S:\Mohrigs Share\Hima_Trinity\10_13_2020_levee_extent_tracing',...
    'transect_xy_300_line_spatial_2020_10_13.txt'));

%ID,Join_Count,TARGET_FID,JOIN_FID,Id,****transectID*****,Join_Cou_1,TARGET_F_1,****levee_extent*****
levee_polygon_transect = textscan(fid,'%f %f %f %f %f %f %f %f %f','HeaderLines',1,'Delimiter',',');
fclose(fid);

% transect levee polygon spatial joins 
polygon_number = [unique(levee_polygon_transect{9})];

for i =1:length(polygon_number)
    indx_unique=find(levee_polygon_transect{9}==polygon_number(i)); %arcgis starts at zero
    transect_polygon{polygon_number(i)+1} = unique(levee_polygon_transect{6}(indx_unique));
end

%% load transect ids with pointbar, counterpointbar, nondepositional, terrace, and erosional  
foldername = 'S:\Mohrigs Share\Hima_Trinity\LeveeCode\transect_extract\2022_04_10';

fid = fopen(fullfile(foldername,'transect_xy_300_line_spatial_2022_04_10_pointbar.txt'));
%FID,Join_Count,TARGET_FID,JOIN_FID,Id,*****transectID,Id_1,L1_orR2
pointbar_transect = textscan(fid,'%f %f %f %f %f %f %f %f','HeaderLines',1,'Delimiter',',');
fclose(fid);

fid = fopen(fullfile(foldername,'transect_xy_300_line_spatial_2022_04_10_counterpointbar.txt'));
%FID,Join_Count,TARGET_FID,JOIN_FID,Id,*****transectID,Id_1,L1_orR2
cpointbar_transect = textscan(fid,'%f %f %f %f %f %f %f %f','HeaderLines',1,'Delimiter',',');
fclose(fid);

fid = fopen(fullfile(foldername,'transect_xy_300_line_spatial_2022_04_10_channeladjustment.txt'));
%FID,Join_Count,TARGET_FID,JOIN_FID,Id,*****transectID,Id_1,L1_orR2
channeladust_transect = textscan(fid,'%f %f %f %f %f %f %f %f','HeaderLines',1,'Delimiter',',');
fclose(fid);

fid = fopen(fullfile(foldername,'transect_xy_300_line_spatial_2022_04_10_nondepositional.txt'));
%FID,Join_Count,TARGET_FID,JOIN_FID,Id,*****transectID,Id_1,L1_orR2
nondepo_transect = textscan(fid,'%f %f %f %f %f %f %f %f','HeaderLines',1,'Delimiter',',');
fclose(fid);

fid = fopen(fullfile(foldername,'transect_xy_300_line_spatial_2022_04_10_terrace.txt'));
%FID,Join_Count,TARGET_FID,JOIN_FID,Id,*****transectID,Id_1,L1_orR2
terrace_transect = textscan(fid,'%f %f %f %f %f %f %f %f','HeaderLines',1,'Delimiter',',');
fclose(fid);

fid = fopen(fullfile(foldername,'transect_xy_300_line_spatial_2022_04_10_erosional.txt'));
%FID,Join_Count,TARGET_FID,JOIN_FID,Id,*****transectID,Id_1,L1_orR2
erosional_transect = textscan(fid,'%f %f %f %f %f %f %f %f','HeaderLines',1,'Delimiter',',');
fclose(fid);

fid = fopen(fullfile(foldername,'transect_xy_300_line_spatial_2022_04_10_levee.txt'));
%FID,Join_Count,TARGET_FID,JOIN_FID,Id,*****transectID,Id_1,L1_orR2
levee2_transect = textscan(fid,'%f %f %f %f %f %f %f %f','HeaderLines',1,'Delimiter',',');
fclose(fid);

%% load migration rates 
foldername = 'S:\Mohrigs Share\Hima_Trinity\Trinity_migration';

fid = fopen(fullfile(foldername,'bends-dm-nov2014_may11_edited.csv'));
%bend #	dist. Downstream	km	max mig	mean mig	median mig	m/yr		x96	y96	bend_96	curvature9	dist_ds96	length96

migrationrate = textscan(fid,'%f %f %f %f %f %f %f %f %f %f %f %f %f %f','HeaderLines',1,'Delimiter',',');
migration_rate = cell2mat(migrationrate);
fclose(fid);


%% match distance downstream between data sets
   distance_downstream_migration = NaN(1,length(migration_rate(:,1)));

for i =1:length(migration_rate(:,1))
   pdist_value =[];
   [pdist_value,pdist_index] = pdist2([centerline(:,1),centerline(:,2)],[migration_rate(i,9),migration_rate(i,10)],'euclidean','Smallest',3);
   if isnan(pdist_value)
   elseif pdist_value(1)> 200 %outside study area for levee study
       distance_downstream_migration(i) = NaN;
   elseif pdist_value(1) <= 50 %if less than 20m away distance downstream is equal to closeset 
       distance_downstream_migration(i) = distance_downstream_automated(pdist_index(1));
   end      
end

%find points with no distance downstream since x,y not avaiable 
[notnan_ddmigration] = ~isnan(distance_downstream_migration);
nontnan_index = find(notnan_ddmigration);
[value,vali]=unique(migration_rate(notnan_ddmigration,2));

% interpolate distance downstream for current frame based on previous frame
distance_downstream_migration(isnan(distance_downstream_migration)) = ...
   interp1(migration_rate(nontnan_index(vali),2).',...
   distance_downstream_migration(nontnan_index(vali)),...
   migration_rate(isnan(distance_downstream_migration),2));

% find distance downstream equilvant of zones based on Smith, Mason,
% Mohrig, 2020 currently in Smith and Mohrig, 2017 framwork Romayor 50.4km
% is 0km in Smith, Mason, Mohrig
%63	upstream extent of BW
%72.4	Liberty Gage
%82.15	transition/backwater boundary
[~,indx_min] =min(abs(63-[migration_rate(:,3)-50.4]));
dist_backwater = distance_downstream_migration(indx_min);
[~,indx_min] =min(abs(82.15-[migration_rate(:,3)-50.4]));
dist_transition = distance_downstream_migration(indx_min);
%% loop through centerline and find swath profile

tic %4hrs
for i = 1:len_center 
    % find xy of transect
    % find orthogonal vector of centerline point before and after
    if i==1 % if at begining of transect use slope of next point 
        v1 =(centerline(i+1,:)-centerline(i,:))/norm(centerline(i+1,:)-centerline(i,:));
        v2 = (centerline(i+2,:)-centerline(i+1,:))/norm(centerline(i+2,:)-centerline(i+1,:));
    elseif i ==len_center %if at end of transect use slope of previous point
        v1 = (centerline(i-1,:)-centerline(i-2,:))/norm(centerline(i-1,:)-centerline(i-2,:));
        v2 = (centerline(i,:)-centerline(i-1,:))/norm(centerline(i,:)-centerline(i-1,:));
    else %for all other transects
        v1 = (centerline(i,:)-centerline(i-1,:))/norm(centerline(i,:)-centerline(i-1,:));
        v2 = (centerline(i+1,:)-centerline(i,:))/norm(centerline(i+1,:)-centerline(i,:));
    end
    v3 = mean([v1;v2]);
    transect_xy{i} = [[centerline(i,1)-v3(2)*linspace(cross_len,cross_space,round(cross_len/cross_space)).';...
        centerline(i,1)+v3(2)*linspace(cross_space,cross_len,round(cross_len/cross_space)).'],...
        [centerline(i,2)+v3(1)*linspace(cross_len,cross_space,round(cross_len/cross_space)).';...
        centerline(i,2)-v3(1)*linspace(cross_space,cross_len,round(cross_len/cross_space)).']];
    % find elevation of transect
    transect_elev{i} = mapinterp(dem_Array,dem_SpatialReference,transect_xy{i}(:,1),transect_xy{i}(:,2));
   % transect_elev_floodplain{i} =  mapinterp(floodplain_dem_Array,floodplain_dem_SpatialReference,transect_xy{i}(:,1),transect_xy{i}(:,2));
    % swath profile perpendicular to transect 
    
    for kk = 1:length(transect_xy{i})
        % find xy of swath transect should be parallel to centerline
        swath_xy = [[transect_xy{i}(kk,1)-v3(1)*linspace(swath_width,cross_space,round(swath_width/cross_space)).';...
            transect_xy{i}(kk,1)+v3(1)*linspace(cross_space,swath_width,round(swath_width/cross_space)).'],...
            [transect_xy{i}(kk,2)-v3(2)*linspace(swath_width,cross_space,round(swath_width/cross_space)).';...
            transect_xy{i}(kk,2)+v3(2)*linspace(cross_space,swath_width,round(swath_width/cross_space)).']];
        % find elevation of swath transect
        swath_elev = mapinterp(dem_Array, dem_SpatialReference,swath_xy(:,1),swath_xy(:,2)); 
        % find detrended elevation of swath transect
       % swath_floodplain_elev = mapinterp(floodplain_dem_Array, floodplain_dem_SpatialReference,swath_xy(:,1),swath_xy(:,2)); 
        
        % find mean elevation of swath transect
        swath_elev_mean(i,kk) =nanmean(swath_elev);
       % swath_floodplain_elev_mean(i,kk) = nanmean(swath_floodplain_elev);
    end
    
end
toc
%% Clip swath if crosses another centerline and find thalweg and levee characteristics for transect 
% find closest centerline points and clip transects for levee crest and extent finding 
 % interpolate centerline into m scale variability 
 swath_elev_mean_clip= NaN(size(swath_elev_mean));
 swath_floodplain_elev_mean_clip =  NaN(size(swath_elev_mean));
 %swath_detrended_elev_mean_clip= NaN(size(swath_elev_mean));
 crossX_clip =NaN(size(swath_elev_mean));
 crossY_clip =NaN(size(swath_elev_mean));
crossZ_clip =NaN(size(swath_elev_mean));
% find thalweg and levee characteristics for transect
thalweg = NaN(length(swath_elev_mean_clip(:,1)),3);
crest_right = NaN(length(swath_elev_mean_clip(:,1)),3);
crest_left = NaN(length(swath_elev_mean_clip(:,1)),3);
extent_right = NaN(length(swath_elev_mean_clip(:,1)),3);
extent_left = NaN(length(swath_elev_mean_clip(:,1)),3);
extent_levee_indx_left = NaN(length(swath_elev_mean_clip(:,1)),1);
extent_levee_indx_right = NaN(length(swath_elev_mean_clip(:,1)),1);
levee_height_left= NaN(length(swath_elev_mean_clip(:,1)),1);
levee_height_right= NaN(length(swath_elev_mean_clip(:,1)),1);
levee_width_left= NaN(length(swath_elev_mean_clip(:,1)),1);
levee_width_right= NaN(length(swath_elev_mean_clip(:,1)),1);
%floodplain_detrend_left = NaN(length(swath_elev_mean_clip(:,1)),5);
floodplain_elev_left = NaN(length(swath_elev_mean_clip(:,1)),5);
floodplain_width_left = NaN(length(swath_elev_mean_clip(:,1)),1);
%floodplain_detrend_right = NaN(length(swath_elev_mean_clip(:,1)),5);
floodplain_elev_right = NaN(length(swath_elev_mean_clip(:,1)),5);
floodplain_width_right = NaN(length(swath_elev_mean_clip(:,1)),1);

tic %take 1.2 hours
start_indx = 1;
for i=  1:len_center

    % For each element of the vector I, I(k) = (segment number of (X1,Y1)) +
    % (how far along this segment the intersection is).Similarly for
    % the vector J and the segments in (X2,Y2).
    [~,~,iout,jout]=intersections(transect_xy{i}(:,1),transect_xy{i}(:,2),[c.X],[c.Y]);
    
    % find all the NaN's where transect pass acros
    % if the distance between centerline and transect is less than 2 remove
    % the transect beyond the centerline (given it's not close to the midpoint
    if length(iout) > 1
        all_indx_center = round(unique(iout));
        
        % left is less than 0
        all_indx_left = all_indx_center((all_indx_center - midpt) <-1);
        % only selects smallest number (closest to midpt)
        if ~isempty(all_indx_left)
            [~,min_indx]=min(abs(all_indx_left-midpt));
            all_indx_left = all_indx_left(min_indx);
        end
        
        % right is greater than 0
        all_indx_right = all_indx_center((all_indx_center - midpt) >1);
        
        if ~isempty(all_indx_right) 
            % only selects smallest number
            [~,min_indx]=min(abs(all_indx_right-midpt));
            all_indx_right = all_indx_right(min_indx);
        end
        
        transect_len = length(transect_xy{i}(:,1)');
        % add buffer around centerline
        if ~isempty(all_indx_left) %left add buffer
            if (all_indx_left+centerline_buffer)< midpt
                all_indx_left = all_indx_left+centerline_buffer;
            end
        end
        if ~isempty(all_indx_right) % right subtract buffer
            if (all_indx_right-centerline_buffer)> midpt
                all_indx_right = all_indx_right-centerline_buffer;
            end
        end
        
        % find new transects
        swath_elev_median_clip_temp =[swath_elev_mean(i,:)];
        swath_elev_median_clip_temp([1:all_indx_left,all_indx_right:transect_len]) = NaN;
        swath_elev_mean_clip(i,:) =swath_elev_median_clip_temp;

        %swath_floodplain_elev_median_clip_temp =[swath_floodplain_elev_mean(i,:)];
        %swath_floodplain_elev_median_clip_temp([1:all_indx_left,all_indx_right:transect_len]) = NaN;
        %swath_floodplain_elev_mean_clip(i,:) =swath_floodplain_elev_median_clip_temp;        
        %swath_detrended_elev_median_clip_temp =[swath_detrended_elev_mean{i,:}];
        %swath_detrended_elev_median_clip_temp([1:all_indx_left,all_indx_right:transect_len]) = NaN;
        %swath_detrended_elev_mean_clip(i,:) =swath_detrended_elev_median_clip_temp;
        crossX_clip(i,:) =transect_xy{i}(:,1);
        %crossX_clip{i}(1:all_indx_left) = NaN;
        %crossX_clip{i}(all_indx_right:transect_len)=NaN;
        crossY_clip(i,:) =transect_xy{i}(:,2);
        %crossY_clip{i}(1:all_indx_left) = NaN;
        %crossY_clip{i}(all_indx_right:transect_len)=NaN;
        crossZ_clip(i,:) = transect_elev{i};
    else
        % keep transect
        %swath_elev_mean_clip(i,:) =swath_elev_mean(i,:);
        %swath_floodplain_elev_mean_clip(i,:) =swath_floodplain_elev_mean(i,:);
        %swath_detrended_elev_mean_clip(i,:) =[swath_detrended_elev_mean{i,:}];
        crossX_clip(i,:) =transect_xy{i}(:,1);
        crossY_clip(i,:) =transect_xy{i}(:,2);
        crossZ_clip(i,:) = transect_elev{i};
    end
    %% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%% Extract channel  and levee characteristics %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % find thalweg
    if bathy_dem ==1
        
   
        %find peak of inverted topography and sort by peak height
        s_thalweg = csaps(1:length(swath_elev_mean_clip(i,:)),swath_elev_mean_clip(i,:),0.001);
        % sort the peaks in descending order where transect is multiplied by -1
        [value_thalweg,location_thalweg]=findpeaks(-fnval(s_thalweg,[1:length(swath_elev_mean_clip(i,:))]),'SortStr','descend');
        % note the highest peak is the thalweg and it will be fist in the desending
        % order
        %sort the location and pick the closest one
        
        %remove any points greater than 200 m from mid point
        closest_thalweg = find(abs(location_thalweg-midpt)<200);
        location_thalweg=location_thalweg(closest_thalweg);
        value_thalweg = value_thalweg(closest_thalweg);
        
        % create a weighted sorting function
        if length(location_thalweg)>1
            [~,loc]=sort([abs(location_thalweg-midpt).',-value_thalweg.']);
            cum_sort = [];
            for j = 1:length(value_thalweg)
                %count 1-weight_thal towards the distance to centerline and
                %weight_thal for the elevation
                cum_sort(j) = sum([(1-weight_thal)*find(loc(:,1)==j),weight_thal*find(loc(:,2)==j)]);
            end
            % use minimum cumulative sort between elevtion and distance to
            % thalweg
            [~,min_indx] = min(cum_sort);
            select_thal = location_thalweg(min_indx);
        elseif length(location_thalweg)==1
            select_thal = location_thalweg(1);
        end
        
    else
        select_thal = midpt;
    end
    thalweg(i,:) = [crossX_clip(i,select_thal)...
        ,crossY_clip(i,select_thal),...
        swath_elev_mean_clip(i,select_thal)];
    
    %% Find levee extent
    % need to convert levee_extent to model space -Parameters.xLowerLeftCoord) -Parameters.yLowerLeftCoord)
    transect_in_polygon=find(levee_polygon_transect{6}==i);
        if ~isempty(transect_in_polygon)
            polygon_number_for_transect =levee_polygon_transect{9}(transect_in_polygon);
            levee_extent_for_transect=find(ismember(levee_extent{4},unique(polygon_number_for_transect)));
            %unique(polygon_number_for_transect)
            [D_extent,I_extent]=pdist2([crossX_clip(i,:).',crossY_clip(i,:).'],...
                [levee_extent{:,5}(levee_extent_for_transect),levee_extent{:,6}(levee_extent_for_transect)],...
                'euclidean','Smallest',1);
            min(D_extent)
            
            if length(find(abs(D_extent)<1)) >= 1
                all_indx_extent = unique(I_extent(abs(D_extent)<2))
                
                % based on crests left is less than 0
                indx_left = all_indx_extent((all_indx_extent - midpt) <-1);
                % only selects smallest number (closest to midpt)
                if ~isempty(indx_left)
                    
                    %remove all levee extent beyond next centerline
                    indx_remove_left = [];
                    for t = 1:length(indx_left)
                        %find the maximum intersect to the left of midpoint
                        indx_max_left = max(iout(iout< 1999));
                        if indx_left(t) <= indx_max_left
                            indx_remove_left = [indx_remove_left,t];
                        end
                    end
                    indx_left(indx_remove_left)=[];
                    
                    if  ~isempty(indx_left)
                        % pick left most indx closest to centerline
                        indx_left=indx_left(end);
                        extent_left(i,:)=[crossX_clip(i,indx_left).',...
                            crossY_clip(i,indx_left).',...
                            swath_elev_mean_clip(i,indx_left)];
                        extent_levee_indx_left(i) = indx_left;
                    end
                end
                
                % based on crests left is greater than 0
                indx_right = all_indx_extent((all_indx_extent - midpt) >1);
                
                
                if ~isempty(indx_right)
                    %remove all levee extent beyond next centerline
                    indx_remove_right = [];
                    for t = 1:length(indx_right)
                        %find the min intersect to the right of midpoint
                        indx_max_right = min(iout(iout> 2010)); 
                        if indx_right(t) >= indx_max_right
                            indx_remove_right = [indx_remove_right,t];
                        end
                    end
                    indx_right(indx_remove_right)=[];
                    
                    if ~isempty(indx_right)
                        % pick left most indx closest to centerline
                        indx_right=indx_right(1);
                        extent_right(i,:)=[crossX_clip(i,indx_right).',...
                            crossY_clip(i,indx_right).',...
                            swath_elev_mean_clip(i,indx_right)];
                        extent_levee_indx_right(i) = indx_right;
                    end
                end
            end
            
            %% find levee crest
            
            % pick the closets centerline
            s_crest = csaps(1:length(swath_elev_mean_clip(i,:)),swath_elev_mean_clip(i,:),0.01);
            [value_crest,location_crest] =findpeaks(fnval(s_crest,[1:length(swath_elev_mean_clip(i,:))]));
            derivates_second = diff(diff(fnval(s_crest,[1:length(swath_elev_mean_clip(i,:))])));
            derivates = abs(diff(fnval(s_crest,[1:length(swath_elev_mean_clip(i,:))])));
            
            % find distance and height to thalweg
            distance_to_center = location_crest-select_thal;
            height_to_thalweg = value_crest - (swath_elev_mean_clip(i,select_thal)); % double minus since inverted transect
            
            % left peak
            left_peaks = find(distance_to_center <0);
            left_peaks_keep = [];
            
            for jj = 1:length(left_peaks)
                if ~isempty(indx_left)
                    % only look at peaks greater than levee extent and above levee
                    % extent
                    if  location_crest(left_peaks(jj)) > indx_left
                        left_peaks_keep =[left_peaks_keep,jj];
                    end
                end
            end
            left_peaks=left_peaks([left_peaks_keep]);
            
%                left_peaks_remove = [];
%             
%                 for jj = 1:length(left_peaks)
%                     % remove points as levee crest below certain quantile of transect
%                     if ~isempty(left_peaks)
%                         if value_crest(left_peaks(jj)) < quantile(swath_elev_mean_clip(i,:),elev_quantile_lower)
%                             left_peaks_remove =[left_peaks_remove,jj];
%                         end
%                     end
%                 end
%                left_peaks([left_peaks_remove]) =[];
            
            if ~isempty(left_peaks)
%                 % sort distance to centerline and elevation (negative elevation to
%                 % make largest first) and 2nd derivative of smoothed curve
%                 
%                 [~,loc]=sort([abs(distance_to_center(left_peaks)).',-value_crest(left_peaks).',...
%                     derivates(location_crest(left_peaks)).']);
%                 %add elevation index and distance to center
%                 cum_sort=[];
%                 for j = 1:length(value_crest(left_peaks))
%                     cum_sort(j) = sum([(weight_loc)*find(loc(:,1)==j),...
%                         weight_elev*find(loc(:,2)==j),weight_diff*find(loc(:,3)==j)]);
%                 end
%                 
%                 % use minimum cumulative sort between elevtion and distance to
%                 % thalweg
%                 min_indx_left = find(cum_sort ==min(cum_sort));
                 
                min_indx_left = (find(value_crest(left_peaks) == nanmax(value_crest(left_peaks)),1,'last'));
                                % if more than one min_indx take left most
                crest_left(i,:) = [crossX_clip(i,location_crest(left_peaks(min_indx_left(1))))...
                    ,crossY_clip(i,location_crest(left_peaks(min_indx_left(1)))),...
                    swath_elev_mean_clip(i,location_crest(left_peaks(min_indx_left(1))))];
            
            end
            
            % right peak
            right_peaks = find(distance_to_center >0);
            right_peaks_keep = [];
            
            for jj = 1:length(right_peaks)
                if ~isempty(indx_right)
                    % only look at peaks less than levee extent
                    if  location_crest(right_peaks(jj)) < indx_right
                        right_peaks_keep =[right_peaks_keep,jj];
                    end
                end
            end
            right_peaks=right_peaks([right_peaks_keep]);
            
%             right_peaks_remove = [];
%             
%                 for jj = 1:length(right_peaks)
%                     % % remove points as levee crest below certain quantile of transect
%                     if ~isempty(right_peaks)
%                         if value_crest(right_peaks(jj)) < quantile(swath_elev_mean_clip(i,:),elev_quantile_lower)
%                             right_peaks_remove =[right_peaks_remove,jj];
%                         end
%                     end
%                 end
%                 right_peaks([right_peaks_remove]) =[];
%             
            
            if ~isempty(right_peaks)
%                 % sort distance to centerline and elevation (negative elevation to
%                 % make largest first)
%                 [~,loc]=sort([abs(distance_to_center(right_peaks)).',-value_crest(right_peaks).',...
%                     derivates(location_crest(right_peaks)).']);
%                 %add elevation index and distance to center
%                 cum_sort=[];
%                 for j = 1:length(value_crest(right_peaks))
%                     cum_sort(j) = sum([(weight_loc)*find(loc(:,1)==j),...
%                         weight_elev*find(loc(:,2)==j),weight_diff*find(loc(:,3)==j)]);
%                 end
%                 
%                 % use minimum cumulative sort between elevtion and distance to
%                 % thalweg
%                 min_indx_right = find(cum_sort ==min(cum_sort));
                % if more than one min_indx take right most
                min_indx_right = (find(value_crest(right_peaks) == nanmax(value_crest(right_peaks)),1,'first'));
                crest_right(i,:) = [crossX_clip(i,location_crest(right_peaks(min_indx_right(end))))...
                    ,crossY_clip(i,location_crest(right_peaks(min_indx_right(end)))),...
                    swath_elev_mean_clip(i,location_crest(right_peaks(min_indx_right(end))))];

            end
        
        %% Find floodplain elevation
%         %left levee
%             if ~isempty(indx_left)
%                 % consider distance in detrended_length if transect long enough
%                 % otherwise use available transect
%                 
%                 if (indx_left-detrended_length)>0
%                     start_left =indx_left-detrended_length;
%                 else
%                     start_left =1;
%                 end
%                 
%                 %        floodplain_detrend_left(i,:) = [nanmedian(swath_detrended_elev_mean_clip(i,start_left:indx_left)),...
%                 %            quantile(swath_detrended_elev_mean_clip(i,start_left:indx_left),0.25),...
%                 %            quantile(swath_detrended_elev_mean_clip(i,start_left:indx_left),0.75),...
%                 %            crossX_clip(i,start_left).',...
%                 %            crossY_clip(i,start_left).'];
%                 floodplain_elev_left(i,:) = [nanmedian(swath_floodplain_elev_mean_clip(i,start_left:indx_left)),...
%                     quantile(swath_floodplain_elev_mean_clip(i,start_left:indx_left),0.25),...
%                     quantile(swath_floodplain_elev_mean_clip(i,start_left:indx_left),0.75),...
%                     crossX_clip(i,start_left).',...
%                     crossY_clip(i,start_left).'];
%                 floodplain_width_left(i) = length(start_left:indx_left)*cross_space;
%             end
%             % right levee
%             if ~isempty(indx_right)
%                 % consider distance in detrended_length if transect long enough
%                 % otherwise use available transect
%                 
%                 if (indx_right+detrended_length)<length(swath_floodplain_elev_mean_clip(i,:))
%                     end_right =indx_right+detrended_length;
%                 else
%                     end_right =length(swath_floodplain_elev_mean_clip(i,:));
%                 end
%                 
%                 %        floodplain_detrend_right(i,:) = [nanmedian(swath_detrended_elev_mean_clip(i,indx_right:end_right)),...
%                 %            quantile(swath_detrended_elev_mean_clip(i,indx_right:end_right),0.25),...
%                 %            quantile(swath_detrended_elev_mean_clip(i,indx_right:end_right),0.75),...
%                 %            crossX_clip(i,end_right).',...
%                 %            crossY_clip(i,end_right).'];
%                 floodplain_elev_right(i,:) = [nanmedian(swath_floodplain_elev_mean_clip(i,indx_right:end_right)),...
%                     quantile(swath_elev_mean_clip(i,indx_right:end_right),0.25),...
%                     quantile(swath_elev_mean_clip(i,indx_right:end_right),0.75),...
%                     crossX_clip(i,end_right).',...
%                     crossY_clip(i,end_right).'];
%                 floodplain_width_right(i) = length(indx_right:end_right)*cross_space;
%             end
        end
    %% find levee height and width
    if ~isnan(extent_levee_indx_left(i)) && ~isempty(left_peaks)
        levee_height_left(i) = crest_left(i,3)-extent_left(i,3);
        levee_width_left(i) = pdist2(extent_left(i,1:2),crest_left(i,1:2)); % crest has higher transect values 
    end
    
    % right side 
    if ~isnan(extent_levee_indx_right(i))&& ~isempty(right_peaks)
        levee_height_right(i) =crest_right(i,3)-extent_right(i,3);
        levee_width_right(i) = pdist2(extent_right(i,1:2),crest_right(i,1:2)); % crest has lower transect values 
    end   

        %% Plotting the cross section in X and Y plane.
    if plotting_transect == 1
        f =figure(i);
        f.Position= [000 000 500 400];
        set(gcf,'Color',[1,1,1])

        hold on
        plot([swath_elev_mean(i,:)],'Color',[0.5,0.5,0.5],'LineWidth',0.5);
        ax1 = plot(swath_elev_mean_clip(i,:),'k','LineWidth',1.5);
        if ~isempty(transect_in_polygon)
            fnplt(s_crest)
        end
        %findpeaks(fnval(s_crest,[1:length(swath_elev_mean_clip(i,:))]),'MinPeakDistance',50,'Annotate','extents','WidthReference','halfheight')
        if ~isempty(left_peaks)
            plot(location_crest(left_peaks(min_indx_left(1))), ...
            swath_elev_mean_clip(i,location_crest(left_peaks(min_indx_left(1)))),'bo' ,'LineWidth',2)
            %plot(index_max_left+(x_left(1)-1),z_left(index_max_left),'ro','LineWidth',2)
        end
        if ~isempty(right_peaks)
            plot(location_crest(right_peaks(min_indx_right(end))), ...
                swath_elev_mean_clip(i,location_crest(right_peaks(min_indx_right(end)))),'bs' ,'LineWidth',2)
            %plot(index_max_right+(x_right(1)-1),z_right(index_max_right),'ro','LineWidth',2)
        end
        
        plot(select_thal, swath_elev_mean_clip(i,select_thal),'co','LineWidth',2 )
        
        if ~isnan(extent_levee_indx_left(i))
            plot(extent_levee_indx_left(i),swath_elev_mean_clip(i,extent_levee_indx_left(i)),'ro','Linewidth',2)
        end
        
        if ~isnan(extent_levee_indx_right(i))
            plot(extent_levee_indx_right(i),swath_elev_mean_clip(i,extent_levee_indx_right(i)),'rs','Linewidth',2)
        end
        
        xlabel('distance along cross section (pixels)','FontSize',12,'FontName','Arial');
        ylabel('z[m ] ','FontSize',12,'FontName','Arial');
        title(['The profile of the cross section Id: ',num2str(i)],'FontSize',13,'FontName','Arial');
        ylim([-12,25])
        xlim([1 length(swath_elev_mean_clip(i,:))])
        pause(0.2)
        saveas(gcf,fullfile('C:\Users\hjh739\Documents\GeoNet2_2\results',...
            '2020_10_13', strcat('Transect_',num2str(i),'.png')))
        
        frame = getframe(gcf);        
        % write gif 
        im{i} = frame2im(frame);
        [A,map] = rgb2ind(im{i},256);
        if i == start_indx
            imwrite(A,map,fullfile('C:\Users\hjh739\Documents\GeoNet2_2\results',...
            '2020_10_13',strcat('Transect_gif','.gif')),'gif','LoopCount',Inf,'DelayTime',0.2);
        else
            imwrite(A,map,fullfile('C:\Users\hjh739\Documents\GeoNet2_2\results',...
            '2020_10_13',strcat('Transect_gif','.gif')),'gif','WriteMode','append','DelayTime',0.2);
        end
        % plot histogram of elelvations 
        close(figure(i))
%         figure(i)
%         histogram(swath_elev_mean_clip(i,:))
%         hold on
%         plot(quantile(swath_elev_mean_clip(i,:),0.5),1,'ks')
%         plot(quantile(swath_elev_mean_clip(i,:),0.20),1,'kd')
%         plot(quantile(swath_elev_mean_clip(i,:),0.95),1,'kd')
%         if ~isempty(left_peaks)
%             plot(swath_elev_mean_clip(i,location_crest(left_peaks(min_indx_left(1)))),1,'bo' ,'LineWidth',2)
%         end
%         if ~isempty(right_peaks)
%             plot(swath_elev_mean_clip(i,location_crest(right_peaks(min_indx_right(end)))),1,'bs' ,'LineWidth',2)
%         end
%         pause(1)
%         close(figure(i))
       
    end
    disp(num2str(i))
    indx_left = [];
    indx_right = [];
    left_peaks =[];
    right_peaks = [];

end
toc
% %% save variables 
% floodplain_elev_left_t=array2table([[1:len_center].',floodplain_elev_left],'VariableNames',{'TransectID','Median','quant25','quant75','XCoord','YCoord'});
% floodplain_elev_left_t =floodplain_elev_left_t(find(~isnan(floodplain_elev_left_t.XCoord)),:);
% floodplain_elev_right_t=array2table([[1:len_center].',floodplain_elev_right],'VariableNames',{'TransectID','Median','quant25','quant75','XCoord','YCoord'});
% floodplain_elev_right_t =floodplain_elev_right_t(find(~isnan(floodplain_elev_right_t.XCoord)),:);
% thalweg_t=array2table([[1:len_center].',thalweg],'VariableNames',{'TransectID','XCoord','YCoord','Elev'});
% thalweg_t =thalweg_t(find(~isnan(thalweg_t.XCoord)),:);
% extent_right_t=array2table([[1:len_center].',extent_right],'VariableNames',{'TransectID','XCoord','YCoord','Elev'});
% extent_right_t =extent_right_t(find(~isnan(extent_right_t.XCoord)),:);
% extent_left_t=array2table([[1:len_center].',extent_left],'VariableNames',{'TransectID','XCoord','YCoord','Elev'});
% extent_left_t =extent_left_t(find(~isnan(extent_left_t.XCoord)),:);
% crest_right_t=array2table([[1:len_center].',crest_right],'VariableNames',{'TransectID','XCoord','YCoord','Elev'});
% crest_right_t=crest_right_t(find(~isnan(crest_right_t.XCoord)),:);
% crest_left_t=array2table([[1:len_center].',crest_left],'VariableNames',{'TransectID','XCoord','YCoord','Elev'});
% crest_left_t =crest_left_t(find(~isnan(crest_left_t.XCoord)),:);
% 
% writetable(floodplain_elev_left_t,'2021_04_02_floodplain_elev_left.csv','WriteVariableNames',0)
% writetable(floodplain_elev_right_t,'2021_04_02_floodplain_elev_right.csv','WriteVariableNames',0)
% writetable(thalweg_t,'2021_04_02_thalweg.csv','WriteVariableNames',0)
% writetable(extent_right_t,'2021_04_02_extent_right.csv','WriteVariableNames',0)
% writetable(extent_left_t,'2021_04_02_extent_left.csv','WriteVariableNames',0)
% writetable(crest_left_t,'2021_04_02_crest_left.csv','WriteVariableNames',0)
% writetable(crest_right_t,'2021_04_02_crest_right.csv','WriteVariableNames',0)
%% Run exisiting data 
cd('S:\Mohrigs Share\Hima_Trinity\LeveeCode\transect_extract\2020_10_13')
load('work_space_2020_10_13.mat')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% rerun levee height and width calc
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% load left bank info %%%%%%%%%%%%%%%%%%%%%%%
fid = fopen(fullfile('S:\Mohrigs Share\Hima_Trinity\10_13_2020_levee_extent_tracing','2020_10_13_crest_left_update.txt'));
%FID,Field1,Field2,Field3,Field4,POINT_X,POINT_Y,elevation
crest_left_update = textscan(fid,'%f %f %f %f %f %f %f %f','HeaderLines',1,'Delimiter',',');
crest_left_update = cell2mat(crest_left_update);
fclose(fid);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% load right bank info %%%%%%%%%%%%%%%%%%%%%%%
fid = fopen(fullfile('S:\Mohrigs Share\Hima_Trinity\10_13_2020_levee_extent_tracing','2020_10_13_crest_right_update.txt'));
%FID,Field1,Field2,Field3,Field4,POINT_X,POINT_Y,elevation
crest_right_update = textscan(fid,'%f %f %f %f %f %f %f %f','HeaderLines',1,'Delimiter',',');
crest_right_update = cell2mat(crest_right_update);
fclose(fid);


%initate updated variables
levee_height_left_update =levee_height_left;
levee_width_left_update =levee_width_left;
levee_height_right_update = levee_height_right;
levee_width_right_update = levee_width_right;
crest_right_updated = crest_right;
crest_left_updated = crest_left;

%left side
for i = 1:length(crest_left_update)
    if crest_left_update(i,8) ~=0
        transect_id_indx = crest_left_update(i,2);
        levee_height_left_update(transect_id_indx) = crest_left_update(i,8)-extent_left(transect_id_indx,3);
        levee_width_left_update(transect_id_indx) = pdist2(extent_left(transect_id_indx,1:2),crest_left_update(i,6:7)); % crest has higher transect values 
        crest_left_updated(transect_id_indx,:)=crest_left_update(i,6:8);
    end
end

% right side
for i = 1:length(crest_right_update)
    if crest_right_update(i,8) ~=0
        transect_id_indx = crest_right_update(i,2);
        levee_height_right_update(transect_id_indx) =crest_right_update(i,8)-extent_right(transect_id_indx,3);
        levee_width_right_update(transect_id_indx) = pdist2(extent_right(transect_id_indx,1:2),crest_right_update(i,6:7)); % crest has lower transect values 
        crest_right_updated(transect_id_indx,:)=crest_right_update(i,6:8);
    end   
end
%% find the 20 point moving average of thalweg and levee crest
    thalweg_temp = interp1(1:length(thalweg(:,3)),thalweg(:,3),find(~isnan(thalweg(:,3))));
    a = 1;
    b = 1/100*ones(1,100);
    thalweg_5km = filtfilt(b,a,thalweg_temp);
    
    % crest 
    % 5km crest
    x_crest_right = distance_downstream_automated(~isnan(crest_right(:,3))).';
    y_crest_right = crest_right(~isnan(crest_right(:,3)),3);
    x_crest_left = distance_downstream_automated(~isnan(crest_left(:,3))).';
    y_crest_left = crest_left(~isnan(crest_left(:,3)),3);

    x_crest = [x_crest_right;x_crest_left];
    [~,x_crest_sort]=sort(x_crest);
    x_crest = x_crest(x_crest_sort);
    y_crest = [y_crest_right;y_crest_left];
    y_crest = y_crest(x_crest_sort);
    crest_5km_temp = filtfilt(b,a,y_crest);
    
    [x_crest_temp, index_x_crest] = unique(x_crest); 
    crest_5km = interp1(x_crest_temp,crest_5km_temp(index_x_crest),distance_downstream_automated);
    % updated 
    crest_right_temp = crest_right_updated(:,3);
    crest_left_temp = crest_left_updated(:,3);
    x_crest_right = distance_downstream_automated(~isnan(crest_right_temp)).';
    y_crest_right = crest_right_temp(~isnan(crest_right_temp));
    x_crest_left = distance_downstream_automated(~isnan(crest_left_temp)).';
    y_crest_left = crest_left_temp(~isnan(crest_left_temp));

    x_crest = [x_crest_right;x_crest_left];
    [~,x_crest_sort]=sort(x_crest);
    x_crest = x_crest(x_crest_sort);
    y_crest = [y_crest_right;y_crest_left];
    y_crest = y_crest(x_crest_sort);
    
    
    crest_5km_temp = filtfilt(b,a,y_crest);
    
    [x_crest_temp, index_x_crest] = unique(x_crest); 
    crest_5km_update = interp1(x_crest_temp,crest_5km_temp(index_x_crest),distance_downstream_automated);
    
    % linear fit 
    [p_linear,S_linear] = polyfit(x_crest,y_crest,1)
    crest_linear_update = polyval(p_linear,distance_downstream_automated);
    
    % polynomial fit
    [p_poly2,S_poly2] = polyfit(x_crest,y_crest,2)
    [crest_poly2_update,delta_crest_poly2_update] = polyval(p_poly2,distance_downstream_automated,S_poly2);
%     figure(1)
%     hold on
%     plot(x_crest,y_crest-polyval(p_linear,x_crest),'.')
%     plot(x_crest,y_crest-polyval(p_poly2,x_crest),'.')
%     legend('linear','poly2')
%     
%    figure(3)
%    hold on
%     histogram(y_crest-polyval(p_linear,x_crest))
%     histogram(y_crest-polyval(p_poly2,x_crest))
%     legend('linear','poly2')
%     figure(2)
%     hold on
%     plot(x_crest,y_crest,'.c')
%     plot(distance_downstream_automated,crest_linear_update,'b-')
%     plot(distance_downstream_automated,crest_5km_update,'b--')
%     plot(distance_downstream_automated,crest_poly2_update,'b-.')
%% levee average 
distance_downstream_automated_bend=[];
thalweg_bend =[];
crest_right_bend =[];
crest_left_bend =[];
crest_bend =[];
extent_right_bend =[];
extent_left_bend =[];
extent_bend =[];
levee_height_right_bend =[];
levee_height_left_bend =[];
levee_height_bend =[];
levee_width_right_bend =[];
levee_width_left_bend =[];
levee_width_bend =[];
% floodplain_detrend_right_5km_bend =[];
% floodplain_detrend_left_5km_bend =[];
% floodplain_detrend_5km_bend =[];

for i = 1:length(transect_polygon)
%polygon_number 
distance_downstream_automated_bend(i,:) = [nanmean(distance_downstream_automated(transect_polygon{i})),nanstd(distance_downstream_automated(transect_polygon{i}))];

thalweg_bend(i,:) = [nanmean(thalweg(transect_polygon{i},3)),nanstd(thalweg(transect_polygon{i},3))];

crest_right_bend(i,:) = [nanmean(crest_right_updated(transect_polygon{i},3)),nanstd(crest_right_updated(transect_polygon{i},3))];
crest_left_bend(i,:) = [nanmean(crest_left_updated(transect_polygon{i},3)),nanstd(crest_left_updated(transect_polygon{i},3))];
crest_bend(i,:)=[nanmean([crest_right_updated(transect_polygon{i},3);crest_left_updated(transect_polygon{i},3)]),...
    nanstd([crest_right_updated(transect_polygon{i},3);crest_left_updated(transect_polygon{i},3)])];

extent_right_bend(i,:) = [nanmean(extent_right(transect_polygon{i},3)),nanstd(extent_right(transect_polygon{i},3))];
extent_left_bend(i,:) = [nanmean(extent_left(transect_polygon{i},3)),nanstd(extent_left(transect_polygon{i},3))];
extent_bend(i,:)=[nanmean([extent_right(transect_polygon{i},3);extent_left(transect_polygon{i},3)]),...
    nanstd([extent_right(transect_polygon{i},3);extent_left(transect_polygon{i},3)])];

levee_height_right_bend(i,:) = [nanmean(levee_height_right_update(transect_polygon{i},1)),nanstd(levee_height_right_update(transect_polygon{i},1))];
levee_height_left_bend(i,:) = [nanmean(levee_height_left_update(transect_polygon{i},1)),nanstd(levee_height_left_update(transect_polygon{i},1))];
levee_height_bend(i,:)=[nanmean([levee_height_right_update(transect_polygon{i},1);levee_height_left_update(transect_polygon{i},1)]),...
    nanstd([levee_height_right_update(transect_polygon{i},1);levee_height_left_update(transect_polygon{i},1)])];

levee_width_right_bend(i,:) = [nanmean(levee_width_right_update(transect_polygon{i},1)),nanstd(levee_width_right_update(transect_polygon{i},1))];
levee_width_left_bend(i,:) = [nanmean(levee_width_left_update(transect_polygon{i},1)),nanstd(levee_width_left_update(transect_polygon{i},1))];
levee_width_bend(i,:)=[nanmean([levee_width_right_update(transect_polygon{i},1);levee_width_left_update(transect_polygon{i},1)]),...
    nanstd([levee_width_right_update(transect_polygon{i},1);levee_width_left_update(transect_polygon{i},1)])];
% 
% floodplain_detrend_right_bend(i,:) = [nanmean(floodplain_detrend_right(transect_polygon{i},1)),nanstd(floodplain_detrend_right(transect_polygon{i},1))];
% floodplain_detrend_left_bend(i,:) = [nanmean(floodplain_detrend_left(transect_polygon{i},1)),nanstd(floodplain_detrend_left(transect_polygon{i},1))];
% floodplain_detrend_bend(i,:)=[nanmean([floodplain_detrend_right(transect_polygon{i},1);floodplain_detrend_left(transect_polygon{i},1)]),...
%     nanstd([floodplain_detrend_right(transect_polygon{i},1);floodplain_detrend_left(transect_polygon{i},1)])];

% floodplain_detrend_right_poly2_bend(i,:) = [nanmean(-crest_poly2_update(transect_polygon{i}).'+floodplain_elev_right(transect_polygon{i},1)),...
%     nanstd(-crest_poly2_update(transect_polygon{i}).'+floodplain_elev_right(transect_polygon{i},1))];
% floodplain_detrend_left_poly2_bend(i,:) = [nanmean(-crest_poly2_update(transect_polygon{i}).'+floodplain_elev_left(transect_polygon{i},1)),...
%     nanstd(-crest_poly2_update(transect_polygon{i}).'+floodplain_elev_left(transect_polygon{i},1))];
% floodplain_detrend_poly2_bend(i,:)=[nanmean([-crest_poly2_update(transect_polygon{i}).'+floodplain_elev_right(transect_polygon{i},1);...
%     -crest_poly2_update(transect_polygon{i}).'+floodplain_elev_left(transect_polygon{i},1)]),...
%     nanstd([-crest_poly2_update(transect_polygon{i}).'+floodplain_elev_right(transect_polygon{i},1);...
%     -crest_poly2_update(transect_polygon{i}).'+floodplain_elev_left(transect_polygon{i},1)])];
end

%% extract averages
% width
nanmean([levee_width_left_update;levee_width_right_update])
nanstd([levee_width_left_update;levee_width_right_update])
nanstd([levee_width_left_update;levee_width_right_update])/nanmean([levee_width_left;levee_width_right_update])
nanmedian([levee_width_left_update;levee_width_right_update])
quantile([levee_width_left_update;levee_width_right_update],.95)
%% height 
nanmean([levee_height_left_update;levee_height_right_update])
nanstd([levee_height_left_update;levee_height_right_update])
nanstd([levee_height_left_update;levee_height_right_update])/nanmean([levee_height_left_update;levee_height_right_update])
nanmedian([levee_height_left_update;levee_height_right_update])
quantile([levee_height_left_update;levee_height_right_update],.95)
%% slope 
levee_slope_left = levee_height_left_update./levee_width_left_update;
levee_slope_right = levee_height_right_update./levee_width_right_update;
nanmean(levee_slope_left(~isinf(levee_slope_left))); %ans = 0.0089
nanmean(levee_slope_right(~isinf(levee_slope_right))); %ans =0.0090
nanmean([levee_slope_right(~isinf(levee_slope_right));levee_slope_left(~isinf(levee_slope_left))]) %0.0115
nanstd([levee_slope_right(~isinf(levee_slope_right));levee_slope_left(~isinf(levee_slope_left))])
nanmedian([levee_slope_right(~isinf(levee_slope_right));levee_slope_left(~isinf(levee_slope_left))])
%nanmean(levee_height_bend(:,1)./levee_width_bend(:,1))
%nanstd(levee_height_bend(:,1)./levee_width_bend(:,1))
%nanmedian(levee_height_bend(:,1)./levee_width_bend(:,1))
%% elevation variations 
crest_residual_right = crest_right_updated(:,3).'-crest_poly2_update;
crest_residual_left = crest_left_updated(:,3).'-crest_poly2_update;

crest_residual_linear_right = crest_right_updated(:,3).'-crest_linear_update;
crest_residual_linear_right=crest_residual_linear_right.';
crest_residual_linear_left = crest_left_updated(:,3).'-crest_linear_update;
crest_residual_linear_left=crest_residual_linear_left.';

nanmean(crest_residual_right)
nanmean(crest_residual_left)

x = distance_downstream_automated./1000;

quasi_uniform_water_idx = find(x<=62);
transition_water_idx = intersect(find(x>=62),find(x<=82));
backwater_water_idx =find(x>=82);

residual_backwater = [crest_residual_right(backwater_water_idx),...
    crest_residual_left(backwater_water_idx)];
residual_transition = [crest_residual_right(transition_water_idx),...
    crest_residual_left(transition_water_idx)];
residual_quasi = [crest_residual_right(quasi_uniform_water_idx),...
    crest_residual_left(quasi_uniform_water_idx)];

residual_backwater_ave =nanmean(residual_backwater);
residual_backwater_std =nanstd(residual_backwater);
residual_backwater_median =quantile(residual_backwater,0.5);
residual_backwater_q25 =quantile(residual_backwater,0.25);
residual_backwater_q75 =quantile(residual_backwater,0.75);

residual_transition_ave =nanmean(residual_transition);
residual_transition_std =nanstd(residual_transition);
residual_transition_median =quantile(residual_transition,0.5);
residual_transition_q25 =quantile(residual_transition,0.25);
residual_transition_q75 =quantile(residual_transition,0.75);

residual_quasi_ave =nanmean(residual_quasi);
residual_quasi_std =nanstd(residual_quasi);
residual_quasi_median =quantile(residual_quasi,0.5);
residual_quasi_q25 =quantile(residual_quasi,0.25);
residual_quasi_q75 =quantile(residual_quasi,0.75);

summary_residual = [residual_quasi_median,residual_quasi_q25,residual_quasi_q75;...
    residual_transition_median,residual_transition_q25,residual_transition_q75;...
    residual_backwater_median,residual_backwater_q25,residual_backwater_q75]

abs_residual_backwater_ave =nanmean(abs(residual_backwater));
abs_residual_backwater_std =nanstd(abs(residual_backwater));
abs_residual_backwater_median =quantile(abs(residual_backwater),0.5);
abs_residual_backwater_q25 =quantile(abs(residual_backwater),0.25);
abs_residual_backwater_q75 =quantile(abs(residual_backwater),0.75);

abs_residual_transition_ave =nanmean(abs(residual_transition));
abs_residual_transition_std =nanstd(abs(residual_transition));
abs_residual_transition_median =quantile(abs(residual_transition),0.5);
abs_residual_transition_q25 =quantile(abs(residual_transition),0.25);
abs_residual_transition_q75 =quantile(abs(residual_transition),0.75);

abs_residual_quasi_ave =nanmean(abs(residual_quasi));
abs_residual_quasi_std =nanstd(abs(residual_quasi));
abs_residual_quasi_median =quantile(abs(residual_quasi),0.5);
abs_residual_quasi_q25 =quantile(abs(residual_quasi),0.25);
abs_residual_quasi_q75 =quantile(abs(residual_quasi),0.75);

summary_abs_residual =[abs_residual_quasi_median,abs_residual_quasi_q25,abs_residual_quasi_q75;...
    abs_residual_transition_median,abs_residual_transition_q25,abs_residual_transition_q75;...
    abs_residual_backwater_median,abs_residual_backwater_q25,abs_residual_backwater_q75]


%% spatial trend distance downstream
figure(99)
set(gcf,'Position',[0,0,454,560])
subplot(3,1,1)
hold on
plot(x,fliplr(crest_right_updated(:,3).'),'.k')
plot(x,fliplr(crest_left_updated(:,3).'),'.k')
plot(x,fliplr(crest_poly2_update))
xlim([0,max(x)])
ax = gca;
ax.FontSize = 8;
ax.FontName = 'Arial';
ax.XTick = [0:10:150];
ax.XDir = 'reverse';
ylabel('evelation (m)')

subplot(3,1,2)
hold on
errorbar(max(x)-x(quasi_uniform_water_idx),...
    repmat(residual_quasi_ave,length(quasi_uniform_water_idx),1),...
    repmat(residual_quasi_std,length(quasi_uniform_water_idx),1),...
    'Color',[0.82,0.82,0.82],'Linewidth',2)
errorbar(max(x)-x(transition_water_idx),...
    repmat(residual_transition_ave,length(transition_water_idx),1),...
    repmat(residual_transition_std,length(transition_water_idx),1),...
    'Color',[0.82,0.82,0.82],'Linewidth',2)
errorbar(max(x)-x(backwater_water_idx),...
    repmat(residual_backwater_ave,length(backwater_water_idx),1),...
    repmat(residual_backwater_std,length(backwater_water_idx),1),...
    'Color',[0.82,0.82,0.82],'Linewidth',2)
plot(x,fliplr(crest_residual_right),'.k')
plot(x,fliplr(crest_residual_left),'.k')
plot(max(x)-x(quasi_uniform_water_idx),...
    repmat(residual_quasi_ave,length(quasi_uniform_water_idx)),'Color',[0.62,0.62,0.62],'Linewidth',2)
plot(max(x)-x(transition_water_idx),...
    repmat(residual_transition_ave,length(transition_water_idx)),'Color',[0.62,0.62,0.62],'Linewidth',2)
plot(max(x)-x(backwater_water_idx),...
    repmat(residual_backwater_ave,length(backwater_water_idx)),'Color',[0.62,0.62,0.62],'Linewidth',2)

%xlabel('distance upstream (km)')
ylabel({'residual away from',' polyfit line (m)'})
xlim([0,max(x)])
ylim([-2,2])
ax = gca;
ax.FontSize = 8;
ax.FontName = 'Arial';
ax.XTick = [0:10:150];
ax.XDir = 'reverse';
legend('mean and std of residual of zone')

subplot(3,1,3)
hold on

errorbar(max(x)-x(quasi_uniform_water_idx),...
    repmat(abs_residual_quasi_ave,length(quasi_uniform_water_idx),1),...
    repmat(abs_residual_quasi_std,length(quasi_uniform_water_idx),1),...
    'Color',[0.82,0.82,0.82],'Linewidth',2)
errorbar(max(x)-x(transition_water_idx),...
    repmat(abs_residual_transition_ave,length(transition_water_idx),1),...
    repmat(abs_residual_transition_std,length(transition_water_idx),1),...
    'Color',[0.82,0.82,0.82],'Linewidth',2)
errorbar(max(x)-x(backwater_water_idx),...
    repmat(abs_residual_backwater_ave,length(backwater_water_idx),1),...
    repmat(abs_residual_backwater_std,length(backwater_water_idx),1),...
    'Color',[0.82,0.82,0.82],'Linewidth',2)

plot(x,fliplr(abs(crest_residual_right)),'.k')
plot(x,fliplr(abs(crest_residual_left)),'.k')

plot(max(x)-x(quasi_uniform_water_idx),...
    repmat(abs_residual_quasi_ave,length(quasi_uniform_water_idx)),'Color',[0.62,0.62,0.62],'Linewidth',2)
plot(max(x)-x(transition_water_idx),...
    repmat(abs_residual_transition_ave,length(transition_water_idx)),'Color',[0.62,0.62,0.62],'Linewidth',2)
plot(max(x)-x(backwater_water_idx),...
    repmat(abs_residual_backwater_ave,length(backwater_water_idx)),'Color',[0.62,0.62,0.62],'Linewidth',2)
legend('mean and std of residual of zone')
xlabel('distance upstream (km)')
ylabel({'absolute residual','away from polyfit line (m)'})
xlim([0,max(x)])
ylim([0,2])
ax = gca;
ax.FontSize = 8;
ax.FontName = 'Arial';
ax.XTick = [0:10:150];
ax.XDir = 'reverse';

%% %%%% test if trend is significant %%%%%%%%%%%%%%%%%%%%%%%

% test for normaility 
%null hypothesis that the data in vector x comes from a standard normal distribution
%1 if the test rejects the null hypothesis at the 5% significance level, or 0 otherwise
h_quasi =kstest(abs(residual_quasi))
h_transition = kstest(abs(residual_transition))
h_backwater = kstest(abs(residual_backwater))

%The p-value for the null hypothesis that the data in each column of the matrix x comes from the same distribution, using a Kruskal-Wallis test. 
%The alternative hypothesis is that not all samples come from the same
%distribution.
% Diestribution doesn't have to be normal

zones = zeros(length(x),1);
zones(quasi_uniform_water_idx) =1;
zones(transition_water_idx) = 2;
zones(backwater_water_idx) =3; 
zones_lr = [zones;zones];
p = kruskalwallis([crest_residual_left,crest_residual_right],zones_lr);
[p,tbl,stats] = kruskalwallis([crest_residual_left,crest_residual_right],zones_lr,'off')
c = multcompare(stats)
% shows that transition zones has mean rank significantly different from
% quasi-uniform and backwater zone; quasi-uniform and backwater zones are
% do not have mean rank significantly different 

p_abs = kruskalwallis(abs([crest_residual_left,crest_residual_right]),zones_lr);

[p_abs,tbl_abs,stats_abs] = kruskalwallis(abs([crest_residual_left,crest_residual_right]),zones_lr,'off')
c_abs = multcompare(stats_abs)
% shows that backwater zones has mean rank significantly different from
% quasi-uniform and transition zone; quasi-uniform and transition zones are
% do not have mean rank significantly different 

%% box plots 
figure(98)
hold on
scatter(zones_lr,abs([crest_residual_left,crest_residual_right]),5,'ok','filled','jitter','on', 'jitterAmount',0.2)
boxplot(abs([crest_residual_left,crest_residual_right]),zones_lr)
ylabel('absolut residual of levee-crest fit (m)')
%% plot histograms 
figure(100)
hold on
histogram(residual_quasi)
histogram(residual_transition)
histogram(residual_backwater)
xlabel('residual away from polyfit line (m)')
ylabel('count')
legend('quasi-uniform zone','transition zone','backwater zone')
hold off

figure(101)
hold on
histogram(abs(residual_quasi))
histogram(abs(residual_transition))
histogram(abs(residual_backwater))
xlabel('absolute residual away from polyfit line (m)')
ylabel('count')
legend('quasi-uniform zone','transition zone','backwater zone')
hold off
%% number of transects 
sum([(~isnan(levee_width_left_update));(~isnan(levee_width_right_update))])
%% Sort bend 
[~,dist_sort]=sort(distance_downstream_automated_bend(:,1));

%% centerline that have levees
m_section=5000;%m
n_step = m_section/50;%dx;
x = distance_downstream_automated;
n_section=round(max(x)/m_section); %number of transects per section


label_dist = {};
n_leveetransect_right=[];
n_leveetransect_left=[];
dist_upstream = (max(x)-distance_downstream_automated)./1000;

for i = 1:n_section
    if i == 1
        n_leveetransect_left(1)= sum(~isnan(levee_width_left_update((1:n_step))))/...
            length(levee_width_left_update((1:n_step)));
        n_leveetransect_right(1)= sum(~isnan(levee_width_right_update((1:n_step))))/...
            length(levee_width_right_update((1:n_step)));
        
        label_dist{i} = [num2str(round(dist_upstream(n_step),1)),'-', num2str(round(dist_upstream(1),1))];
        
    elseif i == n_section
        n_leveetransect_left(i)= sum(~isnan(levee_width_left_update((i*n_step:end))))/...
            length(levee_width_left_update((i*n_step:end)));
        n_leveetransect_right(i)= sum(~isnan(levee_width_right_update((i*n_step:end))))/...
            length(levee_width_right_update((i*n_step:end)));
        label_dist{i} = [num2str(round(dist_upstream(end),1)),'-', num2str(round(dist_upstream(i*n_step),1))];
        
    else
        n_leveetransect_left(i)= sum(~isnan(levee_width_left_update((i*n_step:(i+1)*n_step))))/...
            length(levee_width_left_update((i*n_step:(i+1)*n_step)));
        n_leveetransect_right(i)= sum(~isnan(levee_width_right_update((i*n_step:(i+1)*n_step))))/...
            length(levee_width_right_update((i*n_step:(i+1)*n_step)));
        label_dist{i} = [num2str(round(dist_upstream((i+1)*n_step),1)),'-', num2str(round(dist_upstream(i*n_step),1))];
    end
end
%% centerline that have pointbars, counter pointbar, terraces, channel adjustment, nondepositional
n_pbartransect_right=[];
n_pbartransect_left=[];

n_cpbartransect_right=[];
n_cpbartransect_left=[];

n_ndepotransect_right=[];
n_ndepotransect_left=[];

n_cadjtransect_right=[];
n_cadjtransect_left=[];

n_tertransect_right=[];
n_tertransect_left=[];

n_erotransect_right=[];
n_erotransect_left=[];

n_lev2transect_right=[];
n_lev2transect_left=[];

n_distance_diwnstream = [];

%transect id for centerline
pbar_transect_id = pointbar_transect{6};
cpbar_transect_id = cpointbar_transect{6};
ndepo_transect_id = nondepo_transect{6};
cadj_transect_id = channeladust_transect{6};
ter_transect_id = terrace_transect{6};
ero_transect_id = erosional_transect{6};
lev2_transect_id = levee2_transect{6};

% notes if left == 1 or right == 2 bank
pbar_left_right = pointbar_transect{8};
cpbar_left_right = cpointbar_transect{8};
ndepo_left_right= nondepo_transect{8};
cadj_left_right = channeladust_transect{8};
ter_left_right= terrace_transect{8};
ero_left_right= erosional_transect{8};
lev2_left_right= levee2_transect{8};

for i = 1:n_section
    if i == 1
        % pointbar
        n_pbartransect_left(1)= length(find(pbar_left_right(ismember(pbar_transect_id,1:n_step))==1))/...
            length((1:n_step));
        n_pbartransect_right(1)= length(find(pbar_left_right(ismember(pbar_transect_id,1:n_step))==2))/...
            length((1:n_step)); 
        
        % counterpointbar
        n_cpbartransect_left(1)= length(find(cpbar_left_right(ismember(cpbar_transect_id,1:n_step))==1))/...
            length((1:n_step));
        n_cpbartransect_right(1)= length(find(cpbar_left_right(ismember(cpbar_transect_id,1:n_step))==2))/...
            length(1:n_step); 
        
        % nondepositional
        n_ndepotransect_left(1)= length(find(ndepo_left_right(ismember(ndepo_transect_id,1:n_step))==1))/...
            length((1:n_step));
        n_ndepotransect_right(1)= length(find(ndepo_left_right(ismember(ndepo_transect_id,1:n_step))==2))/...
            length(1:n_step); 
        
        % oxbow/channel adjustment
        n_cadjtransect_left(1)= length(find(cadj_left_right(ismember(cadj_transect_id,1:n_step))==1))/...
            length((1:n_step));
        n_cadjtransect_right(1)= length(find(cadj_left_right(ismember(cadj_transect_id,1:n_step))==2))/...
            length(1:n_step); 
        
        % terrace
        n_tertransect_left(1)= length(find(ter_left_right(ismember(ter_transect_id,1:n_step))==1))/...
            length(1:n_step);
        n_tertransect_right(1)= length(find(ter_left_right(ismember(ter_transect_id,1:n_step))==2))/...
            length(1:n_step); 
        
        % erosional
        n_erotransect_left(1)= length(find(ero_left_right(ismember(ero_transect_id,1:n_step))==1))/...
            length((1:n_step));
        n_erotransect_right(1)= length(find(ero_left_right(ismember(ero_transect_id,1:n_step))==2))/...
            length(1:n_step); 
        
        % levee2
        n_lev2transect_left(1)= length(find(lev2_left_right(ismember(lev2_transect_id,1:n_step))==1))/...
            length((1:n_step));
        n_levee2transect_right(1)= length(find(lev2_left_right(ismember(lev2_transect_id,1:n_step))==2))/...
            length(1:n_step); 
        
        %distance downstream 
        n_distance_downstream(1) = nanmean([distance_downstream_automated(1),distance_downstream_automated(n_step)]);
        
        
    elseif i == n_section
        % pointbar
        n_pbartransect_left(i)= length(find(pbar_left_right(ismember(pbar_transect_id,i*n_step:len_center))==1))/...
            length((i*n_step:len_center));
        n_pbartransect_right(i)= length(find(pbar_left_right(ismember(pbar_transect_id,i*n_step:len_center))==2))/...
            length((i*n_step:len_center));
        
        % counterpointbar
        n_cpbartransect_left(i)= length(find(cpbar_left_right(ismember(cpbar_transect_id,i*n_step:len_center))==1))/...
            length((i*n_step:len_center));
        n_cpbartransect_right(i)= length(find(cpbar_left_right(ismember(cpbar_transect_id,i*n_step:len_center))==2))/...
            length((i*n_step:len_center)); 
        
        % nondepositional
        n_ndepotransect_left(i)= length(find(ndepo_left_right(ismember(ndepo_transect_id,i*n_step:len_center))==1))/...
            length(levee_width_left_update((1:n_step)));
        n_ndepotransect_right(i)= length(find(ndepo_left_right(ismember(ndepo_transect_id,i*n_step:len_center))==2))/...
            length(levee_width_right_update((1:n_step))); 
        
        %  oxbow/channel adjustment
        n_cadjtransect_left(i)= length(find(cadj_left_right(ismember(cadj_transect_id,i*n_step:len_center))==1))/...
            length((i*n_step:len_center));
        n_cadjtransect_right(i)= length(find(cadj_left_right(ismember(cadj_transect_id,i*n_step:len_center))==2))/...
            length((i*n_step:len_center)); 
                
        % terrace
        n_tertransect_left(i)= length(find(ter_left_right(ismember(ter_transect_id,i*n_step:len_center))==1))/...
            length((i*n_step:len_center));
        n_tertransect_right(i)= length(find(ter_left_right(ismember(ter_transect_id,i*n_step:len_center))==2))/...
            length((i*n_step:len_center)); 
        
        % erosional
        n_erotransect_left(i)= length(find(ero_left_right(ismember(ero_transect_id,i*n_step:len_center))==1))/...
            length((i*n_step:len_center));
        n_erotransect_right(i)= length(find(ero_left_right(ismember(ero_transect_id,i*n_step:len_center))==2))/...
            length((i*n_step:len_center)); 
        
        % levee
        n_lev2transect_left(i)= length(find(lev2_left_right(ismember(lev2_transect_id,i*n_step:len_center))==1))/...
            length((i*n_step:len_center));
        n_lev2transect_right(i)= length(find(lev2_left_right(ismember(lev2_transect_id,i*n_step:len_center))==2))/...
            length((i*n_step:len_center)); 
 
        %distance downstream 
        n_distance_downstream(i) = nanmean([distance_downstream_automated(i*n_step),distance_downstream_automated(len_center)]);

    else
        % pointbar
        n_pbartransect_left(i)= length(find(pbar_left_right(ismember(pbar_transect_id,(i*n_step:(i+1)*n_step-1)))==1))/...
            length((i*n_step:(i+1)*n_step-1));
        n_pbartransect_right(i)= length(find(pbar_left_right(ismember(pbar_transect_id,(i*n_step:(i+1)*n_step-1)))==2))/...
             length((i*n_step:(i+1)*n_step-1));
        
         % counterpointbar
        n_cpbartransect_left(i)= length(find(cpbar_left_right(ismember(cpbar_transect_id,(i*n_step:(i+1)*n_step-1)))==1))/...
             length((i*n_step:(i+1)*n_step-1));
        n_cpbartransect_right(i)= length(find(cpbar_left_right(ismember(cpbar_transect_id,(i*n_step:(i+1)*n_step-1)))==2))/...
             length((i*n_step:(i+1)*n_step-1)); 
        
        % nondepositional
        n_ndepotransect_left(i)= length(find(ndepo_left_right(ismember(ndepo_transect_id,(i*n_step:(i+1)*n_step-1)))==1))/...
             length((i*n_step:(i+1)*n_step-1));
        n_ndepotransect_right(i)= length(find(ndepo_left_right(ismember(ndepo_transect_id,(i*n_step:(i+1)*n_step-1)))==2))/...
             length((i*n_step:(i+1)*n_step-1)); 
        
        %  oxbow/channel adjustment
        n_cadjtransect_left(i)= length(find(cadj_left_right(ismember(cadj_transect_id,(i*n_step:(i+1)*n_step-1)))==1))/...
             length((i*n_step:(i+1)*n_step-1));
        n_cadjtransect_right(i)= length(find(cadj_left_right(ismember(cadj_transect_id,(i*n_step:(i+1)*n_step-1)))==2))/...
             length((i*n_step:(i+1)*n_step-1)); 
        
        % terrace
        n_tertransect_left(i)= length(find(ter_left_right(ismember(ter_transect_id,(i*n_step:(i+1)*n_step-1)))==1))/...
             length((i*n_step:(i+1)*n_step-1));
        n_tertransect_right(i)= length(find(ter_left_right(ismember(ter_transect_id,(i*n_step:(i+1)*n_step-1)))==2))/...
             length((i*n_step:(i+1)*n_step-1)); 
        
        % terrace
        n_erotransect_left(i)= length(find(ero_left_right(ismember(ero_transect_id,(i*n_step:(i+1)*n_step-1)))==1))/...
            length((i*n_step:(i+1)*n_step-1));
        n_erotransect_right(i)= length(find(ero_left_right(ismember(ero_transect_id,(i*n_step:(i+1)*n_step-1)))==2))/...
            length((i*n_step:(i+1)*n_step-1)); 
        
                % terrace
        n_lev2transect_left(i)= length(find(lev2_left_right(ismember(lev2_transect_id,(i*n_step:(i+1)*n_step-1)))==1))/...
            length((i*n_step:(i+1)*n_step-1));
        n_lev2transect_right(i)= length(find(lev2_left_right(ismember(lev2_transect_id,(i*n_step:(i+1)*n_step-1)))==2))/...
            length((i*n_step:(i+1)*n_step-1));
        
        %distance downstream 
        n_distance_downstream(i) = nanmean([distance_downstream_automated(i*n_step),distance_downstream_automated((i+1)*n_step-1)]);

    end
end


%% check max number of transect for each is 2
transect_off = [];
for i =1:len_center
    num_intransect = 0;
   
    if sum([length(find(pbar_transect_id==i)),...
    length(find(cpbar_transect_id==i)),...
    length(find(ndepo_transect_id==i)),...
    length(find(cadj_transect_id==i)),...
    length(find(ter_transect_id==i)),...
    length(find(ero_transect_id==i)),...
    length(find(lev2_transect_id==i))]) >2

     transect_off =[transect_off,i];
     i
    end
end
%% total in line centerline of levees
left_riverkm_levee = 50*sum(~isnan(levee_width_left_update(:)))./1000 %km
right_riverkm_levee = 50*sum(~isnan(levee_width_right_update(:)))./1000 %km


%%%%%%%%%%%% make sure everything adds up to 100 %%%%%%%%%%%%%%%%%%%%%%%%%%
[n_pbartransect_right+n_cpbartransect_right+n_ndepotransect_right+n_cadjtransect_right+n_tertransect_right+n_erotransect_right+n_lev2transect_right]*100
[n_pbartransect_left+n_cpbartransect_left+n_ndepotransect_left+n_cadjtransect_left+n_tertransect_left+n_erotransect_left+n_lev2transect_left]*100

%% percentage by region 
bank_type_x = [0:5:max(x)/1000]+2.5;
bank_type_x = bank_type_x(1:end-1);
quasi_uniform_water_type_idx = find(bank_type_x<=62);
transition_water_type_idx = intersect(find(bank_type_x>=62),find(bank_type_x<=82));
backwater_water_type_idx =find(bank_type_x>=82);

%quasi_uniform 
n_low_elev_quasi = sum(n_cadjtransect_left(quasi_uniform_water_type_idx)+...
    n_cpbartransect_left(quasi_uniform_water_type_idx)+...
    n_cadjtransect_right(quasi_uniform_water_type_idx)+...
    n_cpbartransect_left(quasi_uniform_water_type_idx))./...
    (2*length(quasi_uniform_water_type_idx))*100 % in % devided by 2 for left right side and by number of section

%transition zone
n_low_elev_transiiton = sum(n_cadjtransect_left(transition_water_type_idx)+...
    n_cpbartransect_left(transition_water_type_idx)+...
    n_cadjtransect_right(transition_water_type_idx)+...
    n_cpbartransect_right(transition_water_type_idx))./...
    (2*length(transition_water_type_idx))*100 % in % devided by 2 for left right side and by number of section

%transition zone
n_low_elev_backwater = sum(n_cadjtransect_left(backwater_water_type_idx)+...
    n_cpbartransect_left(backwater_water_type_idx)+...
    n_cadjtransect_right(backwater_water_type_idx)+...
    n_cpbartransect_right(backwater_water_type_idx))./...
    (2*length(backwater_water_type_idx))*100 % in % devided by 2 for left right side and by number of section

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% %%%%%%%%%%%%%%%%%%For publication%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

figure(29)
set(gcf,'Position',[500,250,454,360])
subplot(8,1,1:5)

hold on
x = distance_downstream_automated;
ax1 = plot(x./1000,flipud(thalweg(:,3)),'g.','Color',[0.5,0.5,0.5],'MarkerSize',6);
%ax2 = plot(distance_downstream_automated./1000,thalweg_10pt(:,1),'-','Color',[0.3,0.3,0.3],'linewidth',2);
ax3 = plot(x./1000,flipud(crest_right_updated(:,3)),'k.','Color',[255/255    187/255    0],'MarkerSize',6);
plot(distance_downstream_automated./1000,flipud(crest_left_updated(:,3)),'k.','Color',[255/255    187/255    0],'MarkerSize',6)
%plot((max(x)-distance_downstream_automated)./1000,crest_5km,'-','Color',[255/255    187/255    0],'Linewidth',1.5);

plot(distance_downstream_automated./1000,flipud(extent_left(:,3)),'cs','Color',[251/255    101/255    66/255],'MarkerSize',3)
ax4 =plot(distance_downstream_automated./1000,flipud(extent_right(:,3)),'cs','Color',[251/255    101/255    66/255],'MarkerSize',3);


ax5=plot((max(x)-distance_downstream_automated_bend(:,1))./1000,thalweg_bend(:,1),'g.','Color',[0.5,0.5,0.5],'MarkerSize',10,'MarkerEdgeColor','k');
ax6=scatter((max(x)-distance_downstream_automated_bend(:,1))./1000,crest_bend(:,1),10,[255/255    187/255    0],'filled','MarkerEdgeColor','k');
ax7=scatter((max(x)-distance_downstream_automated_bend(:,1))./1000,extent_bend(:,1),10,[251/255    101/255    66/255],'s','filled','MarkerEdgeColor','k');
%scatter((max(x)-distance_downstream_automated_bend(:,1))./1000,floodplain_detrend_5km_bend(:,1)+crest_bend(:,1),10,'ks','filled','MarkerEdgeColor','k');

ylabel('elevation (m)','FontName','Arial')
legend([ax1, ax3, ax4,ax5, ax6, ax7],{'thalweg','levee crest','levee extent',...
    'thalweg levee-ave','levee crest levee-ave','levee extent levee-ave'},'NumColumns',2)
ylim([-10,25])
xlim([0,max(x)/1000])
ax = gca;
ax.FontSize = 8;
ax.FontName = 'Arial';
ax.XTick = [0:10:150];
ax.XTickLabels={[]};
ax.XDir = 'reverse';

subplot(8,1,6:8)

hold on
plot(fliplr(n_leveetransect_right)*100.','Color',[0.4,0.4,0.4])
plot(fliplr(n_leveetransect_left)*100.','Color',[0.4,0.4,0.4]);
az1 =scatter(1:length(n_leveetransect_right),fliplr(n_leveetransect_right)*100.',20,[0.9,0.9,0.9],'filled','MarkerEdgeColor',[0.4,0.4,0.4]);
az2 =scatter(1:length(n_leveetransect_right),fliplr(n_leveetransect_left)*100.',20,[0.5,0.5,0.5],'filled','MarkerEdgeColor',[0.4,0.4,0.4]);

xlim([1,n_section+1])
xlabel('centerline distance upstream (km)','FontName','Arial')
ylabel({'percent of bankline',' with levee (%)'},'FontName','Arial')
legend([az1,az2],'right bank','left bank','Location','northwest')
ax = gca;
ax.FontSize = 8;
ax.FontName = 'Arial';
ax.YTick = [0:20:100];
ax.XTick = [1:1.9836:length(n_leveetransect_right)+1];
ax.XTickLabels={0:10:max(x)/1000};
%xtickangle(45)

%%
figure(15)
hold on
%floodplain detrended elevation vs levee width
%cross correlation

left_update = find(levee_width_left~=levee_width_left_update);
right_update = find(levee_width_right~=levee_width_right_update);
nan_left = ~isnan(levee_width_left_update)&~isnan(floodplain_elev_left(:,1));
nan_right = ~isnan(levee_width_right_update)&~isnan(floodplain_elev_right(:,1));
floodplain_detrend_all = [-crest_5km_update(nan_left).'+floodplain_elev_left(nan_left,1);...
    -crest_poly2_update(nan_right).'+floodplain_elev_right(nan_right,1)];
levee_width_all = [levee_width_left_update(nan_left);levee_width_right_update(nan_right)];

[rho_tau,pval_tau]=corr(floodplain_detrend_poly2_bend(:,1),levee_width_bend(:,1),'Type','Kendall')
[rho_tau,pval_tau]=corr(floodplain_detrend_all,levee_width_all,'Type','Kendall')

plot(-crest_poly2_update.'+floodplain_elev_left(:,1),levee_width_left_update,'.','Color',[0.5,0.5,0.5])
plot(-crest_poly2_update.'+floodplain_elev_right(:,1),levee_width_right_update,'.','Color',[0.5,0.5,0.5])

%plot(-crest_poly2_update(left_update).'+floodplain_elev_left(left_update,1),levee_width_left_update(left_update),'.r')
%plot(-crest_poly2_update(right_update).'+floodplain_elev_right(right_update,1),levee_width_right_update(right_update),'.b')

%ax22=errorbar(floodplain_detrend_5km_bend(:,1),levee_width_bend(:,1),...
%    levee_width_bend(:,2),levee_width_bend(:,2),...
%    floodplain_detrend_5km_bend(:,2),floodplain_detrend_5km_bend(:,2),'.','Color',[0.8,0.8,0.8]);
ax21=scatter(floodplain_detrend_poly2_bend(:,1),levee_width_bend(:,1),5,'k','o','filled','MarkerEdgeColor','k');

hold on

%mdl = fitlm(floodplain_detrend_5km_bend(~isnan(floodplain_detrend_5km_bend(:,1)),1),...
%    (levee_width_bend(~isnan(floodplain_detrend_5km_bend(:,1)),1)))
mdl = fitlm(floodplain_detrend_all,levee_width_all)



 %[b,S] = polyfit(floodplain_detrend_5km_bend(~isnan(floodplain_detrend_5km_bend(:,1)),1),...
 %    log(levee_width_bend(~isnan(floodplain_detrend_5km_bend(:,1)),1)),1);

[b,S] = polyfit(floodplain_detrend_all,log(levee_width_all),1);
 xCalc1 =-3.5:0.1:0.5;   
 [yCalc1,delta1] = polyval(b,xCalc1,S);

yCalc1_exp = exp(yCalc1);
delta1_exp = exp(delta1);

%plot(xCalc1,yCalc1_exp,'k')
%plot(xCalc1,yCalc1_exp - delta1_exp,'--k')
%plot(xCalc1,yCalc1_exp + delta1_exp,'--k')

%legend([ax21,ax22],'levee-average','levee-standard devation');
%text(-1,950,{strcat('\tau =',num2str(round(rho_tau,3)),'p < 0.0001'),'Kendalls tau'},'FontName','Arial','FontSize',7)
text(-.50,1000,{strcat('tau =',num2str(round(rho_tau,3))),'p < 0.0001','Kendalls tau'},'FontName','Arial','FontSize',7)
ylim([0,1500])

xlabel('detrended floodplain elevation (m)','FontName','Arial')
ylabel('levee width (m)','FontName','Arial')
ax = gca;
%set(ax,'YScale','log')
ax.FontSize = 7;
ax.FontName = 'Arial';
set(gcf,'Position',[049   253,290,263])
set(gca,'YMinorTick','on')
%set(gca,'TickLength',[0.03, 0.02])
ax.XTick = [-3.5:1:0.5];
xlim([-3.5,0.5])
%saveas(gcf,['C:\Users\hjh739\Documents\GeoNet2_2\results\2020_07_15\levee_widthvsfloodplain_detrended.png'])


%% all of the percent bankline
figure(28)
set(gcf,'Position',[100,100,550*120/136,744]) %originally 550,744
hold on
subplot(12,1,1:2)
hold on

plot(n_distance_downstream/1000,fliplr(n_lev2transect_right)*100.','Color',[0.4,0.4,0.4])
plot(n_distance_downstream/1000,fliplr(n_lev2transect_left)*100.','--','Color',[0.4,0.4,0.4]);

scatter(n_distance_downstream/1000,fliplr(n_lev2transect_right)*100.',20,[0.9,0.9,0.9],'filled','MarkerEdgeColor',[0.4,0.4,0.4]);
scatter(n_distance_downstream/1000,fliplr(n_lev2transect_left)*100.',20,[0.5,0.5,0.5],'filled')

xlim([10,max(x)./1000])
ylim([0,100])
%xlabel('centerline distance upstream (km)','FontName','Arial')
ylabel({'levee (%)'},'FontName','Arial')
legend('right bank','left bank','Location','northwest')
ax = gca;
ax.FontSize = 10;
ax.FontName = 'Arial';
ax.YTick = [0:20:100];
ax.XTick = [0:10:140];
ax.XTickLabels={''};
ax.XDir = 'reverse';
xtickangle(45)

subplot(12,1,3:4)
hold on
plot(n_distance_downstream/1000,fliplr(n_pbartransect_right)*100.','Color',[0.4,0.4,0.4])
plot(n_distance_downstream/1000,fliplr(n_pbartransect_left)*100.','--','Color',[0.4,0.4,0.4]);

scatter(n_distance_downstream/1000,fliplr(n_pbartransect_right)*100.',20,[0.9,0.9,0.9],'filled','MarkerEdgeColor',[0.4,0.4,0.4]);
scatter(n_distance_downstream/1000,fliplr(n_pbartransect_left)*100.',20,[0.5,0.5,0.5],'filled')

xlim([10,max(x)./1000])
ylim([0,100])
%xlabel('centerline distance upstream (km)','FontName','Arial')
ylabel({'scrollbar (%)'},'FontName','Arial')
%legend('right bank','left bank','Location','northwest')
ax = gca;
ax.FontSize = 10;
ax.FontName = 'Arial';
ax.YTick = [0:20:100];
ax.XTick = [0:10:140];
ax.XDir = 'reverse';
ax.XTickLabels={''};
xtickangle(45)

subplot(12,1,5:6)
hold on
plot(n_distance_downstream/1000,fliplr(n_cpbartransect_right)*100.','Color',[0.4,0.4,0.4])
plot(n_distance_downstream/1000,fliplr(n_cpbartransect_left)*100.','--','Color',[0.4,0.4,0.4]);

scatter(n_distance_downstream/1000,fliplr(n_cpbartransect_right)*100.',20,[0.9,0.9,0.9],'filled','MarkerEdgeColor',[0.4,0.4,0.4]);
scatter(n_distance_downstream/1000,fliplr(n_cpbartransect_left)*100.',20,[0.5,0.5,0.5],'filled')

xlim([10,max(x)./1000])
ylim([0,100])
%xlabel('centerline distance upstream (km)','FontName','Arial')
ylabel({'counter','pointbar (%)'},'FontName','Arial')
%legend('right bank','left bank','Location','northwest')
ax = gca;
ax.FontSize = 10;
ax.FontName = 'Arial';
ax.XDir = 'reverse';
ax.YTick = [0:20:100];
ax.XTick = [0:10:140];
ax.XTickLabels={''};
xtickangle(45)

subplot(12,1,7:8)
hold on
plot(n_distance_downstream/1000,fliplr(n_ndepotransect_right+n_tertransect_right)*100.','Color',[0.4,0.4,0.4])
plot(n_distance_downstream/1000,fliplr(n_ndepotransect_left+n_tertransect_left)*100.','--','Color',[0.4,0.4,0.4]);

scatter(n_distance_downstream/1000,fliplr(n_ndepotransect_right+n_tertransect_right)*100.',20,[0.9,0.9,0.9],'filled','MarkerEdgeColor',[0.4,0.4,0.4]);
scatter(n_distance_downstream/1000,fliplr(n_ndepotransect_left+n_tertransect_left)*100.',20,[0.5,0.5,0.5],'filled')
ylim([0,100])
xlim([10,max(x)./1000])

%xlabel('centerline distance upstream (km)','FontName','Arial')
ylabel({'inactive','surface (%)'},'FontName','Arial')
%legend('right bank','left bank','Location','northwest')
ax = gca;
ax.FontSize = 10;
ax.FontName = 'Arial';
ax.YTick = [0:20:100];
ax.XTick = [0:10:140];
ax.XTickLabels={''};
ax.XDir = 'reverse';
xtickangle(45)

subplot(12,1,9:10)
hold on
plot(n_distance_downstream/1000,fliplr(n_cadjtransect_right)*100.','Color',[0.4,0.4,0.4])
plot(n_distance_downstream/1000,fliplr(n_cadjtransect_left)*100.','--','Color',[0.4,0.4,0.4]);

scatter(n_distance_downstream/1000,fliplr(n_cadjtransect_right)*100.',20,[0.9,0.9,0.9],'filled','MarkerEdgeColor',[0.4,0.4,0.4]);
scatter(n_distance_downstream/1000,fliplr(n_cadjtransect_left)*100.',20,[0.5,0.5,0.5],'filled')
ylim([0,100])
xlim([10,max(x)/1000])

%xlabel('centerline distance upstream (km)','FontName','Arial')
ylabel({'channel','adjustment (%)'},'FontName','Arial')
%legend('right bank','left bank','Location','northwest')
ax = gca;
ax.FontSize = 10;
ax.FontName = 'Arial';
ax.YTick = [0:20:100];
ax.XTick = [0:10:140];
ax.XTickLabels={''};
ax.XDir = 'reverse';
xtickangle(45)

subplot(12,1,11:12)
hold on
plot(n_distance_downstream/1000,fliplr(n_erotransect_right)*100.','Color',[0.4,0.4,0.4])
plot(n_distance_downstream/1000,fliplr(n_erotransect_left)*100.','--','Color',[0.4,0.4,0.4]);

scatter(n_distance_downstream/1000,fliplr(n_erotransect_right)*100.',20,[0.9,0.9,0.9],'filled','MarkerEdgeColor',[0.4,0.4,0.4]);
scatter(n_distance_downstream/1000,fliplr(n_erotransect_left)*100.',20,[0.5,0.5,0.5],'filled')
ylim([0,100])
xlim([10,max(x)/1000])

xlabel('centerline distance upstream (km)','FontName','Arial')
ylabel({'erosion (%)'},'FontName','Arial')
%legend('right bank','left bank','Location','northwest')
ax = gca;
ax.FontSize = 10;
ax.FontName = 'Arial';
ax.YTick = [0:20:100];
ax.XTick = [0:10:140];
ax.XDir = 'reverse';
%ax.XTickLabels={0:10:max(x)/1000};
%ax.XDir = 'reverse';

figure(128)
set(gcf,'Position',[100,100,550*120/136,744]) %originally 550,744
subplot(12,1,11:12)
hold on
plot(max(distance_downstream_automated)./1000-distance_downstream_migration./1000,...
    migration_rate(:,7),'Color',[0.9,0.9,0.9]);
ax = gca;
ax.YTick = [0:2:10];
ylabel({'lateral migration','rate (m/y)'},'FontName','Arial')
ax.FontSize = 10;
xlim([10,max(x)/1000])
ax.FontName = 'Arial';
ax.XTick = [0:10:140];
xlabel('centerline distance upstream (km)','FontName','Arial')

ax.XDir = 'reverse';
%% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%% OLD PLOTS %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%
figure(26)
set(gcf,'Position',[400,050,550,594])
subplot(15,1,1:5)
hold on
ax9=plot((max(x)-distance_downstream_automated)./1000,levee_height_left_update,'.','Color',[0.5,0.5,0.5],'MarkerSize',8);
ax10=plot((max(x)-distance_downstream_automated)./1000,levee_height_right_update,'.','Color',[0.5,0.5,0.5],'MarkerSize',8);
h_shaded1 = patch([fliplr((max(x)-distance_downstream_automated_bend(dist_sort,1)).'./1000),...
    ((max(x)-distance_downstream_automated_bend(dist_sort,1)).'./1000)],...
    [fliplr(levee_height_bend(dist_sort,1).'-levee_height_bend(dist_sort,2).'),...
    levee_height_bend(dist_sort,1).'+levee_height_bend(dist_sort,2).'],...
    'k');
        h_shaded1.FaceColor = [0,0,0];
        h_shaded1.FaceAlpha = 0.1;
        h_shaded1.EdgeColor = 'none';
plot((max(x)-distance_downstream_automated_bend(dist_sort,1))./1000,levee_height_bend(dist_sort,1),'-k');
ax11=scatter((max(x)-distance_downstream_automated_bend(:,1))./1000,levee_height_bend(:,1),10,'k','o','filled','MarkerEdgeColor','k');
legend([ax9,ax11,h_shaded1],'transect','levee-ave','levee-standard devation','Location','northwest');
%legend([ax11,h_shaded1],'levee-ave','levee-standard devation','Location','northwest');
ylim([0,4])

%xlabel('centerline upstream downstream (km)','FontName','Arial')
ylabel('levee height (m)','FontName','Arial')
ax = gca;
ax.FontSize = 8;
ax.FontName = 'Arial';
ax.XTick = [0:10:150];
ax.XTickLabels={[]};
ax.XDir = 'reverse';

axes('Position',[.7 .83 .2 .08])
box on
histogram(levee_height_left_update,'BinLimits',[0,3],'EdgeColor','k','FaceColor',[0.5,0.5,0.5])
hold on 
histogram(levee_height_right_update,'BinLimits',[0,3],'EdgeColor','k','FaceColor',[0.9,0.9,0.9],'FaceAlpha',0.4)
xlabel('levee height (m)')
%legend('left levee','right levee','Location','best')
box off


subplot(15,1,6:10)

%find range of means + standard devation 
width_bend_range = [fliplr(levee_width_bend(dist_sort,1).'-levee_width_bend(dist_sort,2).'),...
    levee_width_bend(dist_sort,1).'+levee_width_bend(dist_sort,2).'];
% if log scale is on uncomment section below 
width_bend_range(width_bend_range<0)=0.1;
hold on
ax12=plot((max(x)-distance_downstream_automated)./1000,levee_width_left_update,'.','Color',[0.5,0.5,0.5],'MarkerSize',8);
plot((max(x)-distance_downstream_automated)./1000,levee_width_right_update,'.','Color',[0.5,0.5,0.5],'MarkerSize',8)
ax13=plot((max(x)-distance_downstream_automated_bend(dist_sort,1))./1000,levee_width_bend(dist_sort,1),'-k','MarkerSize',12);
h_shaded4 = patch([fliplr((max(x)-distance_downstream_automated_bend(dist_sort,1)).'./1000),...
    ((max(x)-distance_downstream_automated_bend(dist_sort,1)).'./1000)],...
    width_bend_range,...
    'k');
h_shaded4.FaceColor = [0,0,0];
h_shaded4.FaceAlpha = 0.1;
h_shaded4.EdgeColor = 'none';
ax14=scatter((max(x)-distance_downstream_automated_bend(:,1))./1000,levee_width_bend(:,1),10,'k','o','filled','MarkerEdgeColor','k');
%legend([ax12,ax14,h_shaded2],'transect','levee-ave','levee-standard devation','Location','northwest');

ylim([0,1500])
%xlabel('centerline distance upstreamstream (km)','FontName','Arial')
ylabel('levee width (m)','FontName','Arial')
ax = gca;
ax.FontSize = 8;
ax.FontName = 'Arial';
ax.XTick = [0:10:150];
ax.XTickLabels={[]};
%ax.YTick = [0:100:1000];
ax.XDir = 'reverse';
%set(gca, 'YScale', 'log')

axes('Position',[.7 .56 .2 .08])
box on
histogram(levee_width_left_update,'BinLimits',[0,1300],'EdgeColor','k','FaceColor',[0.5,0.5,0.5])
hold on 
histogram(levee_width_right_update,'BinLimits',[0,1300],'EdgeColor','k','FaceColor',[0.9,0.9,0.9],'FaceAlpha',0.4)
xlabel('levee width (m)')
legend('left levee','right levee','Location','best')
box off


subplot(15,1,11:15)
hold on
levee_slope_bend(:,1) = (levee_height_bend(dist_sort,1)./levee_width_bend(dist_sort,1));
levee_slope_bend(:,2) =(levee_height_bend(dist_sort,2)./levee_width_bend(dist_sort,2));
levee_slope_bend(isnan(levee_slope_bend(:,2)),2) = 0;

ax12=plot((max(x)-distance_downstream_automated)./1000,levee_height_left_update./levee_width_left_update,'.','Color',[0.5,0.5,0.5],'MarkerSize',8);
plot((max(x)-distance_downstream_automated)./1000,levee_height_right_update./levee_width_right_update,'.','Color',[0.5,0.5,0.5],'MarkerSize',8)

ax13=plot((max(x)-distance_downstream_automated_bend(dist_sort,1))./1000,levee_height_bend(dist_sort,1)./levee_width_bend(dist_sort,1),'-k','MarkerSize',12);
h_shaded3 = patch([fliplr((max(x)-distance_downstream_automated_bend(dist_sort,1)).'./1000),...
    ((max(x)-distance_downstream_automated_bend(dist_sort,1)).'./1000)],...
    [fliplr(levee_slope_bend(:,1).'-levee_slope_bend(:,2).'),...
    levee_slope_bend(:,1).'+levee_slope_bend(:,2).'],...
    'k');
h_shaded3.FaceColor = [0,0,0];
h_shaded3.FaceAlpha = 0.1;
h_shaded3.EdgeColor = 'none';
ax14=scatter((max(x)-distance_downstream_automated_bend(:,1))./1000,levee_height_bend(:,1)./levee_width_bend(:,1),10,'k','o','filled','MarkerEdgeColor','k');
%legend([ax12,ax14,h_shaded2],'transect','levee-ave','levee-standard devation','Location','northwest');
ylim([0,0.08])
xlabel('centerline distance upstreamstream (km)','FontName','Arial')
ylabel('levee slope (-)','FontName','Arial')
ax = gca;
ax.FontSize = 8;
ax.FontName = 'Arial';
ax.XTick = [0:10:150];
ax.YTick = [-0.02:.02:.1];
ax.XDir = 'reverse';

axes('Position',[.7 .28 .2 .08])
box on
histogram(levee_height_left_update./levee_width_left_update,'BinLimits',[0,.08],'EdgeColor','k','FaceColor',[0.5,0.5,0.5])
hold on 
histogram(levee_height_right_update./levee_width_right_update,'BinLimits',[0,.08],'EdgeColor','k','FaceColor',[0.9,0.9,0.9],'FaceAlpha',0.4)
xlabel('levee slope (-)')
%legend('left levee','right levee','Location','best')
box off
%saveas(gcf,['C:\Users\hjh739\Documents\GeoNet2_2\results\2020_10_13\levee_height_and_width_slope_subplots.png'])
%%
figure(25)
set(gcf,'Position',[500,250,550,554])
subplot(10,1,1:5)
hold on
ax9=plot((max(x)-distance_downstream_automated)./1000,levee_height_left,'.','Color',[0.5,0.5,0.5],'MarkerSize',8);
ax10=plot((max(x)-distance_downstream_automated)./1000,levee_height_right,'.','Color',[0.5,0.5,0.5],'MarkerSize',8);
h_shaded1 = patch([fliplr((max(x)-distance_downstream_automated_bend(dist_sort(1:end-1),1)).'./1000),...
    ((max(x)-distance_downstream_automated_bend(dist_sort(1:end-1),1)).'./1000)],...
    [fliplr(levee_height_bend(dist_sort(1:end-1),1).'-levee_height_bend(dist_sort(1:end-1),2).'),...
    levee_height_bend(dist_sort(1:end-1),1).'+levee_height_bend(dist_sort(1:end-1),2).'],...
    'k');
        h_shaded1.FaceColor = [0,0,0];
        h_shaded1.FaceAlpha = 0.1;
        h_shaded1.EdgeColor = 'none';
plot((max(x)-distance_downstream_automated_bend(dist_sort,1))./1000,levee_height_bend(dist_sort,1),'-k');
ax11=scatter((max(x)-distance_downstream_automated_bend(:,1))./1000,levee_height_bend(:,1),20,'k','o','filled','MarkerEdgeColor','k');
legend([ax9,ax11,h_shaded1],'transect','levee-ave','levee-standard devation','Location','northwest');
ylim([-1,4])

%xlabel('centerline upstream downstream (km)','FontName','Arial')
ylabel('levee height (m)','FontName','Arial')
ax = gca;
ax.FontSize = 10;
ax.FontName = 'Arial';
ax.XTick = [0:10:150];
ax.XTickLabels={[]};
ax.XDir = 'reverse';

axes('Position',[.7 .76 .2 .15])
box on
histogram(levee_height_left,'BinLimits',[-1,3],'EdgeColor','k','FaceColor',[0.5,0.5,0.5])
hold on 
histogram(levee_height_right,'BinLimits',[-1,3],'EdgeColor','k','FaceColor',[0.9,0.9,0.9],'FaceAlpha',0.4)
xlabel('levee height (m)')
legend('left levee','right levee','Location','best')
box off

subplot(10,1,6:10)
hold on
ax12=plot((max(x)-distance_downstream_automated)./1000,levee_width_left,'.','Color',[0.5,0.5,0.5],'MarkerSize',8);
plot((max(x)-distance_downstream_automated)./1000,levee_width_right,'.','Color',[0.5,0.5,0.5],'MarkerSize',8)
ax13=plot((max(x)-distance_downstream_automated_bend(dist_sort,1))./1000,levee_width_bend(dist_sort,1),'-k','MarkerSize',12);
h_shaded2 = patch([fliplr((max(x)-distance_downstream_automated_bend(dist_sort(1:end-1),1)).'./1000),...
    ((max(x)-distance_downstream_automated_bend(dist_sort(1:end-1),1)).'./1000)],...
    [fliplr(levee_width_bend(dist_sort(1:end-1),1).'-levee_width_bend(dist_sort(1:end-1),2).'),...
    levee_width_bend(dist_sort(1:end-1),1).'+levee_width_bend(dist_sort(1:end-1),2).'],...
    'k');
        h_shaded2.FaceColor = [0,0,0];
        h_shaded2.FaceAlpha = 0.1;
        h_shaded2.EdgeColor = 'none';
ax14=scatter((max(x)-distance_downstream_automated_bend(:,1))./1000,levee_width_bend(:,1),20,'k','o','filled','MarkerEdgeColor','k');
%legend([ax12,ax14,h_shaded2],'transect','levee-ave','levee-standard devation','Location','northwest');

ylim([0,1500])
xlabel('centerline distance upstreamstream (km)','FontName','Arial')
ylabel('levee width (m)','FontName','Arial')
ax = gca;
ax.FontSize = 10;
ax.FontName = 'Arial';
ax.XTick = [0:10:150];
ax.YTick = [0:200:1400];
ax.XDir = 'reverse';

axes('Position',[.7 .35 .2 .15])
box on
histogram(levee_width_left,'BinLimits',[0,1200],'EdgeColor','k','FaceColor',[0.5,0.5,0.5])
hold on 
histogram(levee_width_right,'BinLimits',[0,1200],'EdgeColor','k','FaceColor',[0.9,0.9,0.9],'FaceAlpha',0.4)
xlabel('levee width (m)')
legend('left levee','right levee','Location','best')
box off
saveas(gcf,['C:\Users\hjh739\Documents\GeoNet2_2\results\2020_10_13\levee_height_and_width_subplots.png'])

%%plot elevation data
figure(i+1)
hax = axes;
hold on
x = distance_downstream_automated;
ax1 = plot(distance_downstream_automated./1000,flipud(thalweg(:,3)),'g.','Color',[0.5,0.5,0.5],'MarkerSize',8);
%ax2 = plot(distance_downstream_automated./1000,thalweg_10pt(:,1),'-','Color',[0.3,0.3,0.3],'linewidth',2);
ax3 = plot(distance_downstream_automated./1000,flipud(crest_right(:,3)),'k.','Color',[255/255    187/255    0],'MarkerSize',8);
plot(distance_downstream_automated./1000,flipud(crest_left(:,3)),'k.','Color',[255/255    187/255    0],'MarkerSize',8)
plot(distance_downstream_automated./1000,flipud(extent_left(:,3)),'cs','Color',[251/255    101/255    66/255],'MarkerSize',4)
ax4 =plot(distance_downstream_automated./1000,flipud(extent_right(:,3)),'cs','Color',[251/255    101/255    66/255],'MarkerSize',4);

ax5=plot((max(x)-distance_downstream_automated_bend(:,1))./1000,thalweg_bend(:,1),'g.','Color',[0.5,0.5,0.5],'MarkerSize',12,'MarkerEdgeColor','k');
ax6=scatter((max(x)-distance_downstream_automated_bend(:,1))./1000,crest_bend(:,1),12,[255/255    187/255    0],'filled','MarkerEdgeColor','k');
ax7=scatter((max(x)-distance_downstream_automated_bend(:,1))./1000,extent_bend(:,1),12,[251/255    101/255    66/255],'s','filled','MarkerEdgeColor','k');
xlabel('centerline distance upstream (km)','FontName','Arial')
ylabel('elevation (m)','FontName','Arial')
legend([ax1, ax3, ax4,ax5, ax6, ax7],{'centerline bed','levee crest','levee extent',...
    'centerline bed levee-ave','levee crest levee-ave','levee extent levee-ave'},'NumColumns',2)

ax = gca;
ax.XTick = [0:10:150];
ax.XDir = 'reverse';
ax.FontSize = 18;
ax.FontName = 'Arial';
set(gcf,'Position',[500,250,1000,550])
saveas(gcf,['C:\Users\hjh739\Documents\GeoNet2_2\results\2020_07_15\elevation_vs_distancedownstream.png'])

%%Plot levee height and width

figure(10)
hold on
ax9=plot((max(x)-distance_downstream_automated)./1000,levee_height_left,'.','Color',[0.5,0.5,0.5],'MarkerSize',8);
ax10=plot((max(x)-distance_downstream_automated)./1000,levee_height_right,'.','Color',[0.5,0.5,0.5],'MarkerSize',8);
h_shaded1 = patch([fliplr((max(x)-distance_downstream_automated_bend(dist_sort,1)).'./1000),...
    ((max(x)-distance_downstream_automated_bend(dist_sort,1)).'./1000)],...
    [fliplr(levee_height_bend(dist_sort,1).'-levee_height_bend(dist_sort,2).'),...
    levee_height_bend(dist_sort,1).'+levee_height_bend(dist_sort,2).'],...
    'k');
        h_shaded1.FaceColor = [0,0,0];
        h_shaded1.FaceAlpha = 0.1;
        h_shaded1.EdgeColor = 'none';
ax11=scatter((max(x)-distance_downstream_automated_bend(:,1))./1000,levee_height_bend(:,1),20,'k','o','filled','MarkerEdgeColor','k');
legend([ax9,ax11,h_shaded1],'transect','levee-ave','levee-standard devation','Location','northwest');
ylim([-1,4])
xlabel('centerline distance upstream (km)','FontName','Arial')
ylabel('levee height (m)','FontName','Arial')
ax = gca;
ax.FontSize = 14;
ax.FontName = 'Arial';
ax.XTick = [0:10:150];
ax.XDir = 'reverse';
set(gcf,'Position',[500,250,1000,550])
axes('Position',[.7 .7 .2 .2])
box on
histogram(levee_height_left,'BinLimits',[-2,2])
hold on 
histogram(levee_height_right,'BinLimits',[-2,2])
xlabel('levee height (m)')
legend('left levee','right levee','Location','best')
box off
saveas(gcf,['C:\Users\hjh739\Documents\GeoNet2_2\results\2020_07_15\levee_height.png'])

figure(20)
hold on
plot(distance_downstream_automated./1000,levee_height_left,'b-')
plot(distance_downstream_automated./1000,levee_height_right,'r-')
ylim([-1,6])
xlabel('centerline distance downstream (km)','FontName','Arial')
ylabel('levee height (m)','FontName','Arial')
ax = gca;
ax.FontSize = 14;
ax.FontName = 'Arial';
set(gcf,'Position',[500,250,1000,550])
saveas(gcf,['C:\Users\hjh739\Documents\GeoNet2_2\results\2020_10_13\levee_height_leftright.png'])



figure(11)
hold on
ax12=plot((max(x)-distance_downstream_automated)./1000,levee_width_left,'.','Color',[0.5,0.5,0.5],'MarkerSize',8);
plot((max(x)-distance_downstream_automated)./1000,levee_width_right,'.','Color',[0.5,0.5,0.5],'MarkerSize',8)
ax13=plot((max(x)-distance_downstream_automated_bend(dist_sort,1))./1000,levee_width_bend(dist_sort,1),'-k','MarkerSize',12);
h_shaded2 = patch([fliplr((max(x)-distance_downstream_automated_bend(dist_sort(1:end-1),1)).'./1000),...
    ((max(x)-distance_downstream_automated_bend(dist_sort(1:end-1),1)).'./1000)],...
    [fliplr(levee_width_bend(dist_sort(1:end-1),1).'-levee_width_bend(dist_sort(1:end-1),2).'),...
    levee_width_bend(dist_sort(1:end-1),1).'+levee_width_bend(dist_sort(1:end-1),2).'],...
    'k');
        h_shaded2.FaceColor = [0,0,0];
        h_shaded2.FaceAlpha = 0.1;
        h_shaded2.EdgeColor = 'none';
ax14=scatter((max(x)-distance_downstream_automated_bend(:,1))./1000,levee_width_bend(:,1),20,'k','o','filled','MarkerEdgeColor','k');
legend([ax12,ax14,h_shaded2],'transect','levee-ave','levee-standard devation','Location','northwest');

ylim([0,1500])
xlabel('centerline distance upstreamstream (km)','FontName','Arial')
ylabel('levee width (m)','FontName','Arial')
ax = gca;
ax.FontSize = 14;
ax.FontName = 'Arial';
ax.XTick = [0:10:150];
ax.XDir = 'reverse';
set(gcf,'Position',[500,250,1000,550])
axes('Position',[.7 .7 .2 .2])
box on
histogram(levee_width_left)
hold on 
histogram(levee_width_right)
xlabel('levee width (m)')
legend('left levee','right levee','Location','best')
box off
saveas(gcf,['C:\Users\hjh739\Documents\GeoNet2_2\results\2020_10_13\levee_width.png'])

figure(21)
hold on
plot(distance_downstream_automated./1000,levee_width_left,'b-')
plot(distance_downstream_automated./1000,levee_width_right,'r-')

xlabel('centerline distance downstream (km)','FontName','Arial')
ylabel('levee width (m)','FontName','Arial')
ax = gca;
ax.FontSize = 14;
ax.FontName = 'Arial';
set(gcf,'Position',[500,250,1000,550])
saveas(gcf,['C:\Users\hjh739\Documents\GeoNet2_2\results\2020_10_13\levee_width_leftright.png'])

figure(12)
hold on
plot((max(x)-distance_downstream_automated)./1000,levee_height_left./levee_width_left,'*','Color',[0.5,0.5,0.5],'MarkerSize',8)
plot((max(x)-distance_downstream_automated)./1000,levee_height_right./levee_width_right,'*','Color',[0.5,0.5,0.5],'MarkerSize',8)
ax7=scatter((max(x)-(distance_downstream_automated_bend(:,1)))./1000,levee_height_bend(:,1)./levee_width_bend(:,1),20,'k','*','filled','MarkerEdgeColor','k');

xlabel('centerline upstream downstream (km)','FontName','Arial')
ylabel('levee slope (-)','FontName','Arial')
ax = gca;
ax.FontSize = 14;
ax.FontName = 'Arial';
ax.XTick = [0:10:150];
ax.XDir = 'reverse';
set(gcf,'Position',[500,250,1000,550])
hold off 
ylim([0,0.08])
axes('Position',[.7 .7 .2 .2])
box on
histogram(levee_height_left./levee_width_left,'BinLimits',[-0.05,0.05])
hold on 
histogram(levee_height_right./levee_width_right,'BinLimits',[-0.05,0.05])
xlabel('levee slope (-)')
legend('left levee','right levee','Location','best')
box off
saveas(gcf,['C:\Users\hjh739\Documents\GeoNet2_2\results\2020_10_13\levee_slope.png'])

figure(22)
hold on
plot(distance_downstream_automated./1000,levee_height_left./levee_width_left,'b-')
plot(distance_downstream_automated./1000,levee_height_right./levee_width_right,'r-')
xlabel('centerline distance downstream (km)','FontName','Arial')
ylabel('levee slope (-)','FontName','Arial')
ax = gca;
ax.FontSize = 14;
ax.FontName = 'Arial';
set(gcf,'Position',[500,250,1000,550])
hold off 
ylim([0,0.08])

saveas(gcf,['C:\Users\hjh739\Documents\GeoNet2_2\results\2020_10_13\levee_slope_leftright.png'])

%floodplain detrended elevation
figure(13)
hold on
ax19=plot((max(x)-distance_downstream_automated)./1000,-crest_5km.'+floodplain_elev_left(:,1),'.','Color',[0.5,0.5,0.5],'MarkerSize',8);
plot((max(x)-distance_downstream_automated)./1000,-crest_5km.'+floodplain_elev_right(:,1),'.','Color',[0.5,0.5,0.5],'MarkerSize',8)
plot((max(x)-distance_downstream_automated_bend(dist_sort,1))./1000,floodplain_detrend_bend(dist_sort,1),'-k','MarkerSize',12);
h_shaded3 = patch([fliplr((max(x)-distance_downstream_automated_bend(dist_sort(1:end-1),1)).'./1000),...
    ((max(x)-distance_downstream_automated_bend(dist_sort(1:end-1),1)).'./1000)],...
    [fliplr(floodplain_detrend_bend(dist_sort(1:end-1),1).'-floodplain_detrend_bend(dist_sort(1:end-1),2).'),...
    floodplain_detrend_bend(dist_sort(1:end-1),1).'+floodplain_detrend_bend(dist_sort(1:end-1),2).'],...
    'k');
        h_shaded3.FaceColor = [0,0,0];
        h_shaded3.FaceAlpha = 0.1;
        h_shaded3.EdgeColor = 'none';
ax20=scatter((max(x)-(distance_downstream_automated_bend(:,1)))./1000,floodplain_detrend_bend(:,1),20,'k','o','filled','MarkerEdgeColor','k');
legend([ax19,ax20,h_shaded3],'transect','levee-ave','levee-standard devation','Location','northwest');
ylim([-4,2])
xlabel('centerline upstream downstream (km)','FontName','Arial')
ylabel('detrended floodplain elevation (m)','FontName','Arial')
ax = gca;
ax.FontSize = 14;
ax.FontName = 'Arial';
ax.XTick = [0:10:150];
ax.XDir = 'reverse';
set(gcf,'Position',[500,250,1000,550])
hold off 
axes('Position',[.7 .7 .2 .2])
box on
histogram(levee_height_left./levee_width_left)
hold on 
histogram(levee_height_right./levee_width_right)
xlabel('detrended floodplain elevation (m)')
legend('left levee','right levee','Location','best')
box off
saveas(gcf,['C:\Users\hjh739\Documents\GeoNet2_2\results\2020_10_13\floodplain_detrended.png'])

figure(23)
hold on
plot(distance_downstream_automated./1000,floodplain_detrend_left(:,1),'b-')
plot(distance_downstream_automated./1000,floodplain_detrend_right(:,1),'r-')
xlabel('centerline distance downstream (km)','FontName','Arial')
ylabel('detrended floodplain elevation (m)','FontName','Arial')
ax = gca;
ax.FontSize = 14;
ax.FontName = 'Arial';
set(gcf,'Position',[500,250,1000,550])
hold off 

saveas(gcf,['C:\Users\hjh739\Documents\GeoNet2_2\results\2020_10_13\floodplain_dtrended_leftright.png'])

%floodplain detrended elevation vs levee width
%cross correlation
[rho_tau,pval_tau]=corr(floodplain_detrend_bend(1:end-1,1),levee_width_bend(1:end-1,1),'Type','Kendall')

figure(14)
hold on

%floodplain detrended elevation vs levee width
%cross correlation
nan_left = ~isnan(levee_width_left)&~isnan(floodplain_elev_left(:,1));
nan_right = ~isnan(levee_width_right)&~isnan(floodplain_elev_right(:,1));
floodplain_detrend_all = [-crest_5km(nan_left).'+floodplain_elev_left(nan_left,1);...
    -crest_5km(nan_right).'+floodplain_elev_right(nan_right,1)];
levee_width_all = [levee_width_left(nan_left);levee_width_right(nan_right)];

[rho_tau,pval_tau]=corr(floodplain_detrend_5km_bend(:,1),levee_width_bend(:,1),'Type','Kendall')
[rho_tau,pval_tau]=corr(floodplain_detrend_all,levee_width_all,'Type','Kendall')

plot(-crest_5km.'+floodplain_elev_left(:,1),levee_width_left,'.','Color',[0.5,0.5,0.5])
plot(-crest_5km.'+floodplain_elev_right(:,1),levee_width_right,'.','Color',[0.5,0.5,0.5])
ax22=errorbar(floodplain_detrend_5km_bend(:,1),levee_width_bend(:,1),...
    levee_width_bend(:,2),levee_width_bend(:,2),...
    floodplain_detrend_5km_bend(:,2),floodplain_detrend_5km_bend(:,2),'.','Color',[0.8,0.8,0.8]);
ax21=scatter(floodplain_detrend_5km_bend(:,1),levee_width_bend(:,1),2,'k','o','filled','MarkerEdgeColor','k');

hold on

mdl = fitlm(floodplain_detrend_5km_bend(~isnan(floodplain_detrend_5km_bend(:,1)),1),...
    (levee_width_bend(~isnan(floodplain_detrend_5km_bend(:,1)),1)))
mdl = fitlm(floodplain_detrend_all,levee_width_all)



%[b,S] = polyfit(floodplain_detrend_5km_bend(~isnan(floodplain_detrend_5km_bend(:,1)),1),...
%     log(levee_width_bend(~isnan(floodplain_detrend_5km_bend(:,1)),1)),1);

[b,S] = polyfit(floodplain_detrend_all,levee_width_all,1);
 xCalc1 =-4:0.1:1;   
 
 [yCalc1,delta1] = polyval(b,xCalc1,S);

 %yCalc1_exp = exp(yCalc1);
%delta1_exp = exp(delta1);

plot(xCalc1,yCalc1,'k')
%plot(xCalc1_sort,yCalc1_sort - delta1_exp(indx_sort),'--k')
%plot(xCalc1_sort,yCalc1_sort + delta1_exp(indx_sort),'--k')

%legend([ax21,ax22],'levee-average','levee-standard devation');
%text(-1,950,{strcat('\tau =',num2str(round(rho_tau,3)),'p < 0.0001'),'Kendalls tau'},'FontName','Arial','FontSize',7)
text(0.20,1200,{strcat('tau =',num2str(round(rho_tau,3))),'p < 0.0001','Kendalls tau'},'FontName','Arial','FontSize',7)
ylim([0,1400])

xlabel('detrended floodplain elevation (m)','FontName','Arial')
ylabel('levee width (m)','FontName','Arial')
ax = gca;
%set(ax,'YScale','log')
ax.FontSize = 7;
ax.FontName = 'Arial';
set(gcf,'Position',[049   253,290,263])
set(gca,'YMinorTick','on')
%set(gca,'TickLength',[0.03, 0.02])
ax.XTick = [-5:1:3];
xlim([-5,2])
%levee width floodplain detrended elevation

figure(15)
set(gcf,'Position',[500,250,550,554])
subplot(10,1,1:5)
hold on
ax19=plot((max(x)-distance_downstream_automated)./1000,-crest_5km.'+floodplain_elev_left(:,1),'.','Color',[0.5,0.5,0.5],'MarkerSize',8);
plot((max(x)-distance_downstream_automated)./1000,-crest_5km.'+floodplain_elev_right(:,1),'.','Color',[0.5,0.5,0.5],'MarkerSize',8)
plot((max(x)-distance_downstream_automated_bend(dist_sort,1))./1000,floodplain_detrend_bend(dist_sort,1),'-k','MarkerSize',12);
h_shaded3 = patch([fliplr((max(x)-distance_downstream_automated_bend(dist_sort(1:end-1),1)).'./1000),...
    ((max(x)-distance_downstream_automated_bend(dist_sort(1:end-1),1)).'./1000)],...
    [fliplr(floodplain_detrend_bend(dist_sort(1:end-1),1).'-floodplain_detrend_bend(dist_sort(1:end-1),2).'),...
    floodplain_detrend_bend(dist_sort(1:end-1),1).'+floodplain_detrend_bend(dist_sort(1:end-1),2).'],...
    'k');
        h_shaded3.FaceColor = [0,0,0];
        h_shaded3.FaceAlpha = 0.1;
        h_shaded3.EdgeColor = 'none';
ax20=scatter((max(x)-(distance_downstream_automated_bend(:,1)))./1000,floodplain_detrend_bend(:,1),20,'k','o','filled','MarkerEdgeColor','k');
legend([ax19,ax20,h_shaded3],'transect','levee-ave','levee-standard devation','Location','northeast');
ylim([-4,2])

%xlabel('centerline upstream downstream (km)','FontName','Arial')
ylabel({'detrended floodplain','elevation (m)'},'FontName','Arial')
ax = gca;
ax.FontSize = 12;
ax.FontName = 'Arial';
ax.XTick = [0:10:150];
ax.XTickLabels={[]};
ax.XDir = 'reverse';
%
%hold off 
%axes('Position',[.7 .7 .2 .2])
% box on
% histogram(levee_height_left./levee_width_left)
% hold on 
% histogram(levee_height_right./levee_width_right)
% xlabel('detrended floodplain elevation (m)')
% legend('left levee','right levee','Location','best')
% box off

subplot(10,1,6:10)
hold on
ax12=plot((max(x)-distance_downstream_automated)./1000,levee_width_left,'.','Color',[0.5,0.5,0.5],'MarkerSize',8);
plot((max(x)-distance_downstream_automated)./1000,levee_width_right,'.','Color',[0.5,0.5,0.5],'MarkerSize',8)
ax13=plot((max(x)-distance_downstream_automated_bend(dist_sort,1))./1000,levee_width_bend(dist_sort,1),'-k','MarkerSize',12);
h_shaded2 = patch([fliplr((max(x)-distance_downstream_automated_bend(dist_sort(1:end-1),1)).'./1000),...
    ((max(x)-distance_downstream_automated_bend(dist_sort(1:end-1),1)).'./1000)],...
    [fliplr(levee_width_bend(dist_sort(1:end-1),1).'-levee_width_bend(dist_sort(1:end-1),2).'),...
    levee_width_bend(dist_sort(1:end-1),1).'+levee_width_bend(dist_sort(1:end-1),2).'],...
    'k');
        h_shaded2.FaceColor = [0,0,0];
        h_shaded2.FaceAlpha = 0.1;
        h_shaded2.EdgeColor = 'none';
ax14=scatter((max(x)-distance_downstream_automated_bend(:,1))./1000,levee_width_bend(:,1),20,'k','o','filled','MarkerEdgeColor','k');
%legend([ax12,ax14,h_shaded2],'transect','levee-ave','levee-standard devation','Location','northwest');

ylim([0,1200])
xlabel('centerline distance upstreamstream (km)','FontName','Arial')
ylabel('levee width (m)','FontName','Arial')
ax = gca;
ax.FontSize = 12;
ax.FontName = 'Arial';
ax.XTick = [0:10:150];
ax.XDir = 'reverse';
%set(gcf,'Position',[500,250,1000,550])
%axes('Position',[.7 .7 .2 .2])
% box on
% histogram(levee_width_left)
% hold on 
% histogram(levee_width_right)
% xlabel('levee width (m)')
% legend('left levee','right levee','Location','best')
% box off
saveas(gcf,['C:\Users\hjh739\Documents\GeoNet2_2\results\2020_10_13\levee_width_and_floodplain_detrended_subplots.png'])

%% percent of bankline plots 
figure(29)
set(gcf,'Position',[500,550,650,544])
subplot(4,1,1:2)
b=bar(1:length(n_leveetransect_left).',[n_leveetransect_left*100.';...
    n_pbartransect_left*100.';...
    n_cpbartransect_left*100.';...
    n_ndepotransect_left*100.';...
    n_cadjtransect_left*100.';...
    n_tertransect_left*100.';...
    ].','stacked');
b(1).FaceColor = [0.9,0.9,0.9];
%b(2).FaceColor = [0.5,0.5,0.5];
b(1).EdgeColor = 'k';
%)
xlim([0,n_section-1])
%xlabel('centerline distance upstream (km)','FontName','Arial')
ylabel({'percent of centerline',' on left bank (m)'},'FontName','Arial')
%legend('levee','pointbar','counterpbar','nondepo','oxbow','terrace','Location','northwest')
ax = gca;
ax.FontSize = 10;
ax.FontName = 'Arial';
ax.YTick = [0:10:110];
ax.XTick = [1:2:length(n_leveetransect_right)];
ax.XTickLabels={''};
xtickangle(45)
%ax.XDir = 'reverse';
%saveas(gcf,['C:\Users\hjh739\Documents\GeoNet2_2\results\2020_10_13\levee_percent_centerline_bar_5000.png'])

%figure(27)
subplot(4,1,3:4)
b=bar(1:length(n_leveetransect_right).',[n_leveetransect_right*100.';...
    n_pbartransect_right*100.';...
    n_cpbartransect_right*100.';...
    n_ndepotransect_right*100.';...
    n_cadjtransect_right*100.';...
    n_tertransect_right*100.';...
    ].','stacked');
b(1).FaceColor = [0.9,0.9,0.9];
%b(2).FaceColor = [0.5,0.5,0.5];
b(1).EdgeColor = 'k';
%set(gcf,'Position',[500,250,650,244])
xlim([0,n_section-1])
xlabel('centerline distance upstream (km)','FontName','Arial')
ylabel({'percent of centerline',' on right bank (m)'},'FontName','Arial')
legend('levee','pointbar','contrpbar','nondepo','oxbow','terrace','Location','best')
ax = gca;
ax.FontSize = 10;
ax.FontName = 'Arial';
ax.YTick = [0:10:110];
ax.XTick = [1:2:length(n_leveetransect_right)];
ax.XTickLabels={label_dist{1:2:end}};
xtickangle(20)
%ax.XDir = 'reverse';
%saveas(gcf,['C:\Users\hjh739\Documents\GeoNet2_2\results\2020_10_13\levee_percent_centerline_bar_5000.png'])

%%

%saveas(gcf,['C:\Users\hjh739\Documents\GeoNet2_2\results\2020_10_13\levee_percent_centerline_points_5000.png'])

%% histogram only
figure(26)
set(gcf,'Position',[400,050,400,800])
subplot(3,1,1)
hold on

histogram(levee_height_left_update,'BinLimits',[-1,3],'EdgeColor','k','FaceColor',[0.5,0.5,0.5])
histogram(levee_height_right_update,'BinLimits',[-1,3],'EdgeColor','k','FaceColor',[0.9,0.9,0.9],'FaceAlpha',0.4)
xlabel('levee height (m)')
%legend('left levee','right levee','Location','northeast')
ax = gca;
ax.FontSize = 10;

subplot(3,1,2)

histogram(levee_width_left_update,'BinLimits',[0,1200],'EdgeColor','k','FaceColor',[0.5,0.5,0.5])
hold on 
histogram(levee_width_right_update,'BinLimits',[0,1200],'EdgeColor','k','FaceColor',[0.9,0.9,0.9],'FaceAlpha',0.4)
xlabel('levee width (m)')
legend('left levee','right levee','Location','northeast')
ax = gca;
ax.FontSize = 10;

subplot(3,1,3)

histogram(levee_height_left_update./levee_width_left_update,'BinLimits',[-0.02,.08],'EdgeColor','k','FaceColor',[0.5,0.5,0.5])
hold on 
histogram(levee_height_right_update./levee_width_right_update,'BinLimits',[-0.02,.08],'EdgeColor','k','FaceColor',[0.9,0.9,0.9],'FaceAlpha',0.4)
xlabel('levee slope (-)')
%legend('left levee','right levee','Location','northeast')
ax = gca;
ax.FontSize = 10;